/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Contents of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph


Revision 1.191 - (show annotations) (download)
Wed Apr 22 19:21:18 2009 UTC (10 years, 4 months ago) by jmc
Branch: MAIN
Changes since 1.190: +1 -45 lines
delete modifs from March 27-29 2009 (with option "-mpi": link *_mpi files
 from "MODS" dir) to return to a strait-forward behavior.

1 #! /usr/bin/env bash
2 #
3 # $Header: /u/gcmpack/MITgcm/tools/genmake2,v 1.190 2009/04/22 18:35:00 utke Exp $
4 #
5 # Makefile generator for MITgcm UV codes
6 # created by cnh 03/98
7 # adapted by aja 06/98
8 # modified by aja 01/00
9 # rewritten in bash by eh3 08/03
10
11 # Search for particular CPP #cmds associated with packages
12 # usage: test_for_package_in_cpp_options CPP_file package_name
13 test_for_package_in_cpp_options() {
14 cpp_options=$1
15 pkg=$2
16 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22 test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23 test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24 }
25
26 # Search for particular CPP #cmds associated with MPI
27 # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28 test_for_mpi_in_cpp_eeoptions() {
29 cpp_options=$1
30 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34 test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36 test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37 test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38 }
39
40 # Search for particular string in a file. Return 1 if detected, 0 if not
41 # usage: test_for_string_in_file file string
42 test_for_string_in_file() {
43 file=$1
44 strng=$2
45 grep -i "$strng" $file > /dev/null 2>&1
46 RETVAL=$?
47 if test "x${RETVAL}" = x0 ; then
48 printf "Error: In $file there is an illegal line: "
49 grep -i "$strng" $file
50 exit 99
51 fi
52 return 0
53 }
54
55 # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
56 # the package list.
57 expand_pkg_groups() {
58 new_packages=
59 PKG_GROUPS=$ROOTDIR"/pkg/pkg_groups"
60 if test -r $PKG_GROUPS ; then
61 cat $PKG_GROUPS | sed -e 's/#.*$//g' | sed -e 's/:/ : /g' > ./p1.tmp
62 cat ./p1.tmp | $AWK '(NF>2 && $2==":"){ print $0 }' > ./p2.tmp
63 matched=0
64 for i in $PACKAGES ; do
65 line=`grep "^ *$i" ./p2.tmp`
66 RETVAL=$?
67 if test "x$RETVAL" = x0 ; then
68 matched=1
69 replace=`echo $line | $AWK '{ $1=""; $2=""; print $0 }'`
70 echo " replacing \"$i\" with: $replace"
71 new_packages="$new_packages $replace"
72 else
73 new_packages="$new_packages $i"
74 fi
75 done
76 PACKAGES=$new_packages
77 rm -f ./p[1,2].tmp
78 return $matched
79 else
80 echo "Warning: can't read package groups definition file: $PKG_GROUPS"
81 fi
82 }
83
84 # Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
85 # cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
86 check_for_broken_Ff() {
87 # Do we have defaults for $FS and/or $FS90 ?
88 tfs=f
89 tfs9=f90
90 if test "x$FS" != x ; then
91 tfs="$FS"
92 fi
93 if test "x$FS90" != x ; then
94 tfs9="$FS90"
95 fi
96
97 # First check the ability to create a *.F/.f pair.
98 cat <<EOF >> genmake_hello.F
99 program hello
100 write(*,*) 'hi'
101 stop
102 end
103 EOF
104 cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
105 RETVAL=$?
106 if test "x$RETVAL" != x0 ; then
107 if test "x$FS" = x ; then
108 FS='for'
109 FS90='fr9'
110 check_for_broken_Ff
111 else
112 cat <<EOF 2>&1
113 ERROR: Your file system cannot distinguish between *.F and *.f files
114 (fails the "cp" test) and this program cannot find a suitable
115 replacement extension. Please try a different build environment or
116 contact the <MITgcm-support@mitgcm.org> list for help.
117
118 EOF
119 exit -1
120 fi
121 return
122 fi
123 rm -f genmake_hello.*
124
125 # Check the ability of ${MAKE} and ${LN} to use the current set
126 # of extensions.
127 cat <<EOF >> genmake_hello.F
128 program hello
129 write(*,*) 'hi'
130 stop
131 end
132 EOF
133 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
134 cat <<EOF >> $MAKEFILE
135 .SUFFIXES:
136 .SUFFIXES: .$tfs .F
137 .F.$tfs:
138 $LN \$< \$@
139 EOF
140 $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141 RETVAL=$?
142 if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143 if test "x$FS" = x ; then
144 FS='for'
145 FS90='fr9'
146 check_for_broken_Ff
147 else
148 cat <<EOF 2>&1
149 ERROR: Your file system cannot distinguish between *.F and *.f files
150 (fails the "make/ln" test) and this program cannot find a suitable
151 replacement extension. Please try a different build environment or
152 contact the <MITgcm-support@mitgcm.org> list for help.
153
154 EOF
155 exit -1
156 return
157 fi
158 fi
159 rm -f genmake_hello.* $MAKEFILE
160 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
161
162 # If we make it here, use the extensions
163 FS=$tfs
164 FS90=$tfs9
165 return
166 }
167
168
169 look_for_makedepend() {
170
171 # The "original" makedepend is part of the Imake system that is
172 # most often distributed with XFree86 or with an XFree86 source
173 # package. As a result, many machines (eg. generic Linux) do not
174 # have a system-default "makedepend" available. For those
175 # systems, we have two fall-back options:
176 #
177 # 1) a makedepend implementation shipped with the cyrus-imapd
178 # package: ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179 #
180 # 2) a known-buggy xmakedpend shell script
181 #
182 # So the choices are, in order:
183 #
184 # 1) use the user-specified program
185 # 2) use a system-wide default
186 # 3) locally build and use the cyrus implementation
187 # 4) fall back to the buggy local xmakedpend script
188 #
189 if test "x${MAKEDEPEND}" = x ; then
190 which makedepend > /dev/null 2>&1
191 RV0=$?
192 test -f $MAKEFILE && mv -f $MAKEFILE $MAKEFILE".tst"
193 # echo 'MAKEFILE="'$MAKEFILE'"'
194 cat <<EOF >> $MAKEFILE
195 # THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196 #
197 # Some "makedepend" implementations will die if they cannot
198 # find a Makefile -- so this file is here to gives them an
199 # empty one to find and parse.
200 EOF
201 cat <<EOF >> genmake_tc.f
202 program test
203 write(*,*) 'test'
204 stop
205 end
206 EOF
207 makedepend genmake_tc.f > /dev/null 2>&1
208 RV1=$?
209 test -f $MAKEFILE && rm -f $MAKEFILE
210 test -f $MAKEFILE".tst" && mv -f $MAKEFILE".tst" $MAKEFILE
211 if test "x${RV0}${RV1}" = x00 ; then
212 MAKEDEPEND=makedepend
213 else
214 echo " a system-default makedepend was not found."
215
216 # Try to build the cyrus implementation
217 build_cyrus_makedepend
218 RETVAL=$?
219 if test "x$RETVAL" != x0 ; then
220 MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221 fi
222 rm -f ./genmake_cy_md
223 fi
224 else
225 # echo "MAKEDEPEND=${MAKEDEPEND}"
226 echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227 RETVAL=$?
228 if test x"$RETVAL" = x0 ; then
229 build_cyrus_makedepend
230 fi
231 fi
232 }
233
234
235 build_cyrus_makedepend() {
236 rm -f ./genmake_cy_md
237 (
238 cd $ROOTDIR/tools/cyrus-imapd-makedepend \
239 && ./configure > /dev/null 2>&1 \
240 && make > /dev/null 2>&1
241 if test -x ./makedepend.exe ; then
242 $LN ./makedepend.exe ./makedepend
243 fi
244 ./makedepend ifparser.c > /dev/null 2>&1 \
245 && echo "true"
246 ) > ./genmake_cy_md
247 grep true ./genmake_cy_md > /dev/null 2>&1
248 RETVAL=$?
249 rm -f ./genmake_cy_md
250 if test "x$RETVAL" = x0 ; then
251 MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252 return 0
253 else
254 echo "WARNING: unable to build cyrus-imapd-makedepend"
255 return 1
256 fi
257 }
258
259
260 build_embed_encode()
261 {
262 printf " building the embed-encode utility... "
263 if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264 if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265 echo
266 echo " Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267 echo
268 EMBED_SRC=f
269 return 1
270 fi
271 clist="cc gcc c89 $CC"
272 for ic in $clist ; do
273 comm="$ic -o encode_files encode_files.c"
274 ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275 RETVAL=$?
276 if test "x$RETVAL" = x0 ; then
277 echo "OK"
278 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279 return 0
280 fi
281 done
282 echo
283 echo " Error: unable to build $ROOTDIR/embed_encode/encode_files"
284 echo " so it has been disabled"
285 echo
286 EMBED_SRC=f
287 return 1
288 fi
289 echo "OK"
290 DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291 }
292
293
294 # Guess possible config options for this host
295 find_possible_configs() {
296
297 tmp1=`uname`"_"`uname -m`
298 tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
299 tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
300 tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
301 tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
302 tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
303 PLATFORM=$tmp3
304 echo $PLATFORM | grep cygwin > /dev/null 2>&1 && PLATFORM=cygwin_ia32
305 OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
306 echo " The platform appears to be: $PLATFORM"
307
308 echo "test" > test
309 ln -s ./test link
310 RETVAL=$?
311 if test "x${RETVAL}" = x0 ; then
312 LN="ln -s"
313 else
314 echo "Error: \"ln -s\" does not appear to work on this system!"
315 echo " For help, please contact <MITgcm-support@mitgcm.org>."
316 exit 1
317 fi
318 rm -f test link
319
320 if test "x$CPP" = x ; then
321 CPP="cpp -traditional -P"
322 fi
323
324 look_for_makedepend
325
326 #================================================================
327 # look for possible C compilers
328 tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329 p_CC=
330 for c in $tmp ; do
331 rm -f ./genmake_hello.c ./genmake_hello
332 cat >> genmake_hello.c << EOF
333 #include <stdio.h>
334 int main(int argc, char **argv) {
335 printf("Hello!\n");
336 return 0;
337 }
338 EOF
339 $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340 RETVAL=$?
341 if test "x${RETVAL}" = x0 ; then
342 p_CC="$p_CC $c"
343 fi
344 done
345 rm -f ./genmake_hello.c ./genmake_hello
346 if test "x${p_CC}" = x ; then
347 cat 1>&2 <<EOF
348
349 Error: No C compilers were found in your path. Please specify one using:
350
351 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352 2) the CC or MITGCM_CC environment variables.
353
354 EOF
355 exit 1
356 else
357 echo " The possible C compilers found in your path are:"
358 echo " "$p_CC
359 if test "x$CC" = x ; then
360 CC=`echo $p_CC | $AWK '{print $1}'`
361 echo " Setting C compiler to: "$CC
362 fi
363 fi
364
365 #================================================================
366 # look for possible FORTRAN compilers
367 tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368 p_FC=
369 for c in $tmp ; do
370 rm -f ./hello.f ./hello
371 cat >> hello.f <<EOF
372 program hello
373 do i=1,3
374 print *, 'hello world : ', i
375 enddo
376 end
377 EOF
378 $c -o hello hello.f > /dev/null 2>&1
379 RETVAL=$?
380 if test "x${RETVAL}" = x0 ; then
381 p_FC="$p_FC $c"
382 fi
383 done
384 rm -f ./hello.f ./hello
385 if test "x${p_FC}" = x ; then
386 cat 1>&2 <<EOF
387
388 Error: No Fortran compilers were found in your path. Please specify one using:
389
390 1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391 2) a command-line option (eg. "-fc NAME"), or
392 3) the FC or MITGCM_FC environment variables.
393
394 EOF
395 exit 1
396 else
397 echo " The possible FORTRAN compilers found in your path are:"
398 echo " "$p_FC
399 fi
400
401 # Use the first of the compilers found in the current PATH
402 # that has a correctly-named optfile
403 if test "x$OPTFILE" = x -a "x$FC" = x ; then
404 for i in $p_FC ; do
405 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406 if test -r $OPTFILE ; then
407 echo " Setting OPTFILE to: "$OPTFILE
408 break
409 fi
410 done
411 fi
412
413 if test "x$OPTFILE" = x ; then
414 OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
415 if test ! -r $OPTFILE ; then
416 echo " I looked for the file "$OPTFILE" but did not find it"
417 fi
418 fi
419 # echo " The options file: $p_OF"
420 # echo " appears to match so we'll use it."
421 # for i in $p_FC ; do
422 #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
423 #if test -r $p_OF ; then
424 # OPTFILE=$p_OF
425 # echo " The options file: $p_OF"
426 # echo " appears to match so we'll use it."
427 # break
428 #fi
429 # done
430 if test "x$OPTFILE" = x ; then
431 cat 1>&2 <<EOF
432
433 Error: No options file was found in: $ROOTDIR/tools/build_options/
434 that matches this platform ("$PLATFORM") and the compilers found in
435 your path. Please specify an "optfile" using:
436
437 1) the command line (eg. "-optfile=path/to/OPTFILE"), or
438 2) the MITGCM_OF environment variable.
439
440 If you need help, please contact the developers at <MITgcm-support@mitgcm.org>.
441
442 EOF
443 exit 1
444 fi
445
446 # # look for possible MPI libraries
447 # mpi_libs=
448 # mpi_fort=`which mpif77 2>/dev/null`
449 # RETVAL=$?
450 # if test "x${RETVAL}" = x0 ; then
451 # cat >>test.f <<EOF
452 # PROGRAM HELLO
453 # DO 10, I=1,10
454 # PRINT *,'Hello World'
455 # 10 CONTINUE
456 # STOP
457 # END
458 # EOF
459 # eval "$mpi_fort -showme test.f > out"
460 # RETVAL=$?
461 # if test "x${RETVAL}" = x0 ; then
462 # a=`cat out`
463 # for i in $a ; do
464 # case $i in
465 # -*)
466 # mpi_libs="$mpi_libs $i" ;;
467 # esac
468 # done
469 # echo "The MPI libs appear to be:"
470 # echo " "$mpi_libs
471 # fi
472 # rm -f test.f out
473 # fi
474
475 }
476
477 # Parse the package dependency information
478 get_pdepend_list() {
479
480 # strip the comments and then convert the dependency file into
481 # two arrays: PNAME, DNAME
482 cat $1 | sed -e 's/#.*$//g' \
483 | $AWK 'BEGIN{nn=0;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME["nn"]="$1"\nDNAME["nn"]="$i} }' \
484 > ./.pd_tmp
485 . ./.pd_tmp
486 rm -f ./.pd_tmp
487
488 printf "PNAME = "${}
489 }
490
491
492 # Explain usage
493 usage() {
494 cat <<EOF
495
496 Usage: "$0" [OPTIONS]
497 where [OPTIONS] can be:
498
499 -help | --help | -h | --h
500 Print this help message and exit.
501
502 -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
503 -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
504 Use "NAME" as the adoptfile. By default, the file at
505 "tools/adjoint_options/adjoint_default" will be used.
506
507 -nooptfile | --nooptfile
508 -optfile NAME | --optfile NAME | -of NAME | --of NAME
509 -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
510 Use "NAME" as the optfile. By default, an attempt will be
511 made to find an appropriate "standard" optfile in the
512 tools/build_options/ directory.
513
514 -pdepend NAME | --pdepend NAME
515 -pdepend=NAME | --pdepend=NAME
516 Get package dependency information from "NAME".
517
518 -pdefault NAME | --pdefault NAME
519 -pdefault=NAME | --pdefault=NAME
520 Get the default package list from "NAME".
521
522 -make NAME | -m NAME
523 --make=NAME | -m=NAME
524 Use "NAME" for the MAKE program. The default is "make" but
525 many platforms, "gmake" is the preferred choice.
526
527 -makefile NAME | -mf NAME
528 --makefile=NAME | -mf=NAME
529 Call the makefile "NAME". The default is "Makefile".
530
531 -makedepend NAME | -md NAME
532 --makedepend=NAME | -md=NAME
533 Use "NAME" for the MAKEDEPEND program.
534
535 -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
536 -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
537 Specify the location of the MITgcm ROOTDIR as "NAME".
538 By default, genamke will try to find the location by
539 looking in parent directories (up to the 5th parent).
540
541 -mods NAME | --mods NAME | -mo NAME | --mo NAME
542 -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
543 Here, "NAME" specifies a list of directories that are
544 used for additional source code. Files found in the
545 "mods list" are given preference over files of the same
546 name found elsewhere.
547
548 -disable NAME | --disable NAME
549 -disable=NAME | --disable=NAME
550 Here "NAME" specifies a list of packages that we don't
551 want to use. If this violates package dependencies,
552 genamke will exit with an error message.
553
554 -enable NAME | --enable NAME
555 -enable=NAME | --enable=NAME
556 Here "NAME" specifies a list of packages that we wish
557 to specifically enable. If this violates package
558 dependencies, genamke will exit with an error message.
559
560 -standarddirs NAME | --standarddirs NAME
561 -standarddirs=NAME | --standarddirs=NAME
562 Here, "NAME" specifies a list of directories to be
563 used as the "standard" code.
564
565 -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
566 -fc=NAME | --fc=NAME
567 Use "NAME" as the fortran compiler. By default, genmake
568 will search for a working compiler by trying a list of
569 "usual suspects" such as g77, f77, etc.
570
571 -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572 Use "NAME" as the C compiler. By default, genmake
573 will search for a working compiler by trying a list of
574 "usual suspects" such as gcc, c89, cc, etc.
575
576 -[no]ieee | --[no]ieee
577 Do or don't use IEEE numerics. Note that this option
578 *only* works if it is supported by the OPTFILE that
579 is being used.
580
581 -ignoretime | -ignore_time | --ignoretime | --ignore_time
582 Ignore all the "wall clock" routines entirely. This will
583 not in any way hurt the model results -- it simply means
584 that the code that checks how long the model spends in
585 various routines will give junk values.
586
587 -ts | --ts
588 Produce timing information per timestep
589 -papis | --papis
590 Produce summary MFlop/s (and IPC) with PAPI per timestep
591 -pcls | --pcls
592 Produce summary MFlop/s etc. with PCL per timestep
593 -foolad | --foolad
594 Fool the AD code generator
595 -papi | --papi
596 Performance analysis with PAPI
597 -pcl | --pcl
598 Performance analysis with PCL
599 -hpmt | --hpmt
600 Performance analysis with the HPM Toolkit
601
602 -gsl | --gsl
603 Use GSL to control floating point rounding and precision
604 -devel | --devel
605 Add additional warning and debugging flags for development
606
607 -mpi | --mpi
608 Include MPI header files and link to MPI libraries
609 -mpi=PATH | --mpi=PATH
610 Include MPI header files and link to MPI libraries using MPI_ROOT
611 set to PATH. i.e. Include files from \$PATH/include, link to libraries
612 from \$PATH/lib and use binaries from \$PATH/bin.
613
614 -omp | --omp
615 Activate OpenMP code + use Compiler option OMPFLAG
616 -omp=OMPFLAG | --omp=OMPFLAG
617 Activate OpenMP code + use Compiler option OMPFLAG
618
619 -es | --es | -embed-source | --embed-source
620 Embed a tarball containing the full source code
621 (including the Makefile, etc.) used to build the
622 executable [off by default]
623
624 -bash NAME
625 Explicitly specify the Bourne or BASH shell to use
626
627 While it is most often a single word, the "NAME" variables specified
628 above can in many cases be a space-delimited string such as:
629
630 --enable pkg1 --enable 'pkg1 pkg2' --enable 'pkg1 pkg2 pkg3'
631 -mods=dir1 -mods='dir1' -mods='dir1 dir2 dir3'
632 -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
633
634 which, depending upon your shell, may need to be single-quoted.
635
636 For more detailed genmake documentation, please see:
637
638 http://mitgcm.org/devel_HOWTO/
639
640 EOF
641
642 exit 1
643 }
644
645 # Build a CPP macro to automate calling C routines from FORTRAN
646 get_fortran_c_namemangling() {
647
648 #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
649 if test ! "x$FC_NAMEMANGLE" = x ; then
650 return 0
651 fi
652
653 default_nm="#define FC_NAMEMANGLE(X) X ## _"
654
655 cat > genmake_test.c <<EOF
656 void tcall( char * string ) { tsub( string ); }
657 EOF
658 $MAKE genmake_test.o >> genmake_warnings 2>&1
659 RETVAL=$?
660 if test "x$RETVAL" != x0 ; then
661 FC_NAMEMANGLE=$default_nm
662 cat <<EOF>> genmake_errors
663
664 WARNING: C test compile fails
665 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
666 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
667 EOF
668 return 1
669 fi
670 c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
671 RETVAL=$?
672 if test "x$RETVAL" != x0 ; then
673 FC_NAMEMANGLE=$default_nm
674 cat <<EOF>> genmake_warnings
675
676 WARNING: The "nm" command failed.
677 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
678 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here
679 EOF
680 return 1
681 fi
682 cat > genmake_tcomp.$FS <<EOF
683 subroutine tcall( string )
684 character*(*) string
685 call tsub( string )
686 end
687 EOF
688 $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
689 RETVAL=$?
690 if test "x$RETVAL" != x0 ; then
691 FC_NAMEMANGLE=$default_nm
692 cat <<EOF>> genmake_warnings
693
694 WARNING: FORTRAN test compile fails -- please see "genmake_errors"
695 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
696 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
697 EOF
698 return 1
699 fi
700 f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
701 RETVAL=$?
702 if test "x$RETVAL" != x0 ; then
703 FC_NAMEMANGLE=$default_nm
704 cat <<EOF>> genmake_warnings
705
706 WARNING: The "nm" command failed.
707 WARNING: We'll try to use: FC_NAMEMANGLE='$FC_NAMEMANGLE'
708 WARNING: Please contact <MITgcm-support@mitgcm.org> if you need help here.
709 EOF
710 return 1
711 fi
712
713 c_a=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
714 f_a=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 1 | sed -e 's|Y||'`
715 c_b=`echo $c_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
716 f_b=`echo $f_tcall | sed -e 's|tcall|Y Y|' | cut -d ' ' -f 2 | sed -e 's|Y||'`
717
718 nmangle="X"
719 if test "x$c_a" != "x$f_a" ; then
720 comm="echo x$f_a | sed -e 's|x$c_a||'"
721 a=`eval $comm`
722 nmangle="$a ## $nmangle"
723 fi
724 if test "x$c_b" != "x$f_b" ; then
725 comm="echo x$f_b | sed -e 's|x$c_b||'"
726 b=`eval $comm`
727 nmangle="$nmangle ## $b"
728 fi
729
730 FC_NAMEMANGLE="#define FC_NAMEMANGLE(X) $nmangle"
731
732 # cleanup the testing files
733 rm -f genmake_tcomp.* genmake_test.*
734 }
735
736
737 check_HAVE_CLOC() {
738 get_fortran_c_namemangling
739 cat <<EOF > genmake_tc_1.c
740 $FC_NAMEMANGLE
741 #include <stdio.h>
742 #include <stdlib.h>
743 #include <unistd.h>
744 #include <assert.h>
745 #include <sys/time.h>
746 void FC_NAMEMANGLE(cloc) ( double *curtim )
747 {
748 struct timeval tv1;
749 gettimeofday(&tv1 , (void *)NULL );
750 *curtim = (double)((tv1.tv_usec)+(tv1.tv_sec)*1.E6);
751 *curtim = *curtim/1.E6;
752 }
753 EOF
754 COMM="$CC $CFLAGS -c genmake_tc_1.c"
755 echo $COMM >> genmake_warnings
756 $COMM >> genmake_warnings 2>&1
757 RET_C=$?
758 cat <<EOF > genmake_tc_2.$FS
759 program hello
760 REAL*8 wtime
761 external cloc
762 call cloc(wtime)
763 print *," HELLO WORLD", wtime
764 end
765 EOF
766 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
767 echo $COMM >> genmake_warnings
768 $COMM >> genmake_warnings 2>&1
769 RET_F=$?
770 test -x ./genmake_tc && ./genmake_tc >> genmake_warnings 2>&1
771 RETVAL=$?
772 if test "x$RETVAL" = x0 ; then
773 HAVE_CLOC=t
774 DEFINES="$DEFINES -DHAVE_CLOC"
775 fi
776 rm -f genmake_tc*
777 }
778
779
780 check_HAVE_SIGREG() {
781 if test ! "x$HAVE_SIGREG" = x ; then
782 return
783 fi
784 get_fortran_c_namemangling
785 cat <<EOF > genmake_tc_1.c
786 $FC_NAMEMANGLE
787 #include <stdlib.h>
788 #include <stdio.h>
789 #include <signal.h>
790 #include <errno.h>
791 #include <ucontext.h>
792
793 int * ip;
794
795 static void killhandler(
796 unsigned int sn, siginfo_t si, struct ucontext *sc )
797 {
798 *ip = *ip + 1;
799 return;
800 }
801
802 void FC_NAMEMANGLE(sigreg) (int * aip)
803 {
804 struct sigaction s;
805 ip = aip;
806 s.sa_flags = SA_SIGINFO;
807 s.sa_sigaction = (void *)killhandler;
808 if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
809 printf("Sigaction returned error = %d\n", errno);
810 exit(0);
811 }
812 return;
813 }
814 EOF
815 COMM="$CC $CFLAGS -c genmake_tc_1.c"
816 echo $COMM >> genmake_warnings
817 $COMM >> genmake_warnings 2>&1
818 RET_C=$?
819 cat <<EOF > genmake_tc_2.$FS
820 program hello
821 integer anint
822 common /iv/ anint
823 external sigreg
824 call sigreg(anint)
825 end
826 EOF
827 echo >> genmake_warnings
828 echo "running: check_HAVE_SIGREG()" >> genmake_warnings
829 cat genmake_tc_2.$FS >> genmake_warnings
830 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
831 echo $COMM >> genmake_warnings
832 $COMM >> genmake_warnings 2>&1
833 RETVAL=$?
834 if test "x$RETVAL" = x0 ; then
835 HAVE_SIGREG=t
836 DEFINES="$DEFINES -DHAVE_SIGREG"
837 fi
838 rm -f genmake_tc*
839 }
840
841
842 check_HAVE_SETRLSTK() {
843 if test "x$HAVE_SETRLSTK" = xt ; then
844 DEFINES="$DEFINES -DHAVE_SETRLSTK"
845 return
846 fi
847 if test ! "x$HAVE_SETRLSTK" = x ; then
848 return
849 fi
850 get_fortran_c_namemangling
851 cat <<EOF > genmake_tc_1.c
852 $FC_NAMEMANGLE
853 #include <sys/time.h>
854 #include <sys/resource.h>
855 #include <unistd.h>
856 void FC_NAMEMANGLE(setrlstk) ()
857 {
858 struct rlimit rls;
859 rls.rlim_cur = RLIM_INFINITY;
860 rls.rlim_max = RLIM_INFINITY;
861 setrlimit(RLIMIT_STACK, &rls);
862 return;
863 }
864 EOF
865 COMM="$CC $CFLAGS -c genmake_tc_1.c"
866 echo $COMM >> genmake_warnings
867 $COMM >> genmake_warnings 2>&1
868 RET_C=$?
869 cat <<EOF > genmake_tc_2.$FS
870 program hello
871 external setrlstk
872 call setrlstk()
873 end
874 EOF
875 echo >> genmake_warnings
876 echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
877 cat genmake_tc_2.$FS >> genmake_warnings
878 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
879 echo $COMM >> genmake_warnings
880 $COMM >> genmake_warnings 2>&1
881 RETVAL=$?
882 if test "x$RETVAL" = x0 ; then
883 HAVE_SETRLSTK=t
884 DEFINES="$DEFINES -DHAVE_SETRLSTK"
885 fi
886 rm -f genmake_tc*
887 }
888
889
890 check_HAVE_STAT() {
891 get_fortran_c_namemangling
892 cat <<EOF > genmake_tc_1.c
893 $FC_NAMEMANGLE
894 #include <stdio.h>
895 #include <stdlib.h>
896 #include <unistd.h>
897 #include <sys/stat.h>
898 #include <sys/types.h>
899 void FC_NAMEMANGLE(tfsize) ( int *nbyte )
900 {
901 char name[512];
902 struct stat astat;
903
904 name[0] = 'a'; name[1] = '\0';
905 if (! stat(name, &astat))
906 *nbyte = (int)(astat.st_size);
907 else
908 *nbyte = -1;
909 }
910 EOF
911 COMM="$CC $CFLAGS -c genmake_tc_1.c"
912 echo $COMM >> genmake_warnings
913 $COMM >> genmake_tc.log 2>&1
914 RET_C=$?
915 cat <<EOF > genmake_tc_2.$FS
916 program hello
917 integer nbyte
918 call tfsize(nbyte)
919 print *," HELLO WORLD", nbyte
920 end
921 EOF
922 echo >> genmake_warnings
923 echo "running: check_HAVE_STAT()" >> genmake_warnings
924 cat genmake_tc_2.$FS >> genmake_warnings
925 COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
926 echo $COMM >> genmake_warnings
927 $COMM >> genmake_tc.log 2>&1
928 RETVAL=$?
929 if test "x$RETVAL" = x0 ; then
930 HAVE_STAT=t
931 DEFINES="$DEFINES -DHAVE_STAT"
932 fi
933 rm -f genmake_tc*
934 }
935
936
937 check_netcdf_libs() {
938 if test ! "x$SKIP_NETCDF_CHECK" = x ; then
939 return
940 fi
941 echo >> genmake_warnings
942 echo "running: check_netcdf_libs()" >> genmake_warnings
943 cat <<EOF > genmake_tnc.F
944 program fgennc
945 #include "netcdf.inc"
946 EOF
947 if test ! "x$MPI" = x ; then
948 echo '#include "mpif.h"' >> genmake_tnc.F
949 fi
950 cat <<EOF >> genmake_tnc.F
951 integer iret, ncid, xid
952 iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
953 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
954 iret = nf_def_dim(ncid, 'X', 11, xid)
955 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
956 iret = nf_close(ncid)
957 IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
958 end
959 EOF
960 echo "=== genmake_tnc.F ===" > genmake_tnc.log
961 cat genmake_tnc.F >> genmake_tnc.log
962 echo "=== genmake_tnc.F ===" >> genmake_tnc.log
963 RET_CPP=f
964 COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
965 echo "$COMM" >> genmake_tnc.log
966 eval $COMM > genmake_tnc.$FS 2>/dev/null && RET_CPP=t
967 if test "x$RET_CPP" = xf ; then
968 echo " WARNING: CPP failed to pre-process the netcdf test." \
969 >> genmake_tnc.log
970 echo " Please check that \$INCLUDES is properly set." \
971 >> genmake_tnc.log
972 fi
973 echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
974 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
975 $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
976 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
977 RET_COMPILE=$?
978 cat genmake_tnc.log >> genmake_warnings
979
980 #EH3 Remove test program execution for machines that either disallow
981 #EH3 execution or cannot support it (eg. cross-compilers)
982 #EH3
983 #EH3 test -x ./genmake_tnc && ./genmake_tnc >> genmake_tnc.log 2>&1
984 #EH3 RETVAL=$?
985 #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
986
987 if test "x$RET_COMPILE" = x0 ; then
988 HAVE_NETCDF=t
989 else
990 # try again with "-lnetcdf" added to the libs
991 echo "try again with added '-lnetcdf'" > genmake_tnc.log
992 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
993 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
994 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
995 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
996 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
997 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
998 RET_COMPILE=$?
999 cat genmake_tnc.log >> genmake_warnings
1000 if test "x$RET_COMPILE" = x0 ; then
1001 LIBS="$LIBS -lnetcdf"
1002 HAVE_NETCDF=t
1003 else
1004 # try again with "-lnetcdff" added to the libs
1005 echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
1006 echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
1007 echo " && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
1008 echo " && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
1009 cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null \
1010 && $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1 \
1011 && $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
1012 RET_COMPILE=$?
1013 cat genmake_tnc.log >> genmake_warnings
1014 if test "x$RET_COMPILE" = x0 ; then
1015 LIBS="$LIBS -lnetcdff -lnetcdf"
1016 HAVE_NETCDF=t
1017 fi
1018 fi
1019 fi
1020 rm -f genmake_tnc*
1021 }
1022
1023
1024
1025 ###############################################################################
1026 # Sequential part of script starts here
1027 ###############################################################################
1028
1029 # Set defaults here
1030 COMMANDL="$0 $@"
1031
1032 PLATFORM=
1033 LN=
1034 S64=
1035 KPP=
1036 #FC=
1037 #CC=gcc
1038 #CPP=
1039 LINK=
1040 DEFINES=
1041 PACKAGES=
1042 ENABLE=
1043 DISABLE=
1044 # MAKEFILE=
1045 # MAKEDEPEND=
1046 PDEPEND=
1047 DUMPSTATE=t
1048 PDEFAULT=
1049 OPTFILE=
1050 INCLUDES="-I. $INCLUDES"
1051 FFLAGS=
1052 FOPTIM=
1053 FEXTRAFLAGS=
1054 USE_EXTENDED_SRC=
1055 EXTENDED_SRC_FLAG=
1056 CFLAGS=
1057 KFLAGS1=
1058 KFLAGS2=
1059 #LDADD=
1060 LIBS=
1061 KPPFILES=
1062 NOOPTFILES=
1063 NOOPTFLAGS=
1064 MPI=
1065 MPIPATH=
1066 OMP=
1067 OMPFLAG=
1068 TS=
1069 PAPIS=
1070 PCLS=
1071 FOOLAD=
1072 PAPI=
1073 PCL=
1074 HPMT=
1075 GSL=
1076 DEVEL=
1077 HAVE_TEST_L=
1078
1079 # DEFINES checked by test compilation or command-line
1080 HAVE_SYSTEM=
1081 HAVE_FDATE=
1082 FC_NAMEMANGLE=
1083 HAVE_CLOC=
1084 # HAVE_SETRLSTK=
1085 HAVE_STAT=
1086 HAVE_NETCDF=
1087 HAVE_ETIME=
1088 IGNORE_TIME=
1089
1090 MODS=
1091 TOOLSDIR=
1092 SOURCEDIRS=
1093 INCLUDEDIRS=
1094 STANDARDDIRS="USE_THE_DEFAULT"
1095
1096 G2ARGS=
1097 BASH=
1098 PWD=`pwd`
1099 test "x$MAKE" = x && MAKE=make
1100 test "x$AWK" = x && AWK=awk
1101 EMBED_SRC=
1102 THISHOST=`hostname`
1103 THISCWD=`pwd`
1104 THISDATE=`date`
1105 THISUSER=`echo $USER`
1106 THISVER=
1107 MACHINE=`uname -a`
1108 EXECUTABLE=
1109 EXEHOOK=
1110 EXEDIR=
1111 PACKAGES_CONF=
1112 IEEE=
1113 if test "x$MITGCM_IEEE" != x ; then
1114 IEEE=$MITGCM_IEEE
1115 fi
1116 FS=
1117 FS90=
1118
1119 AUTODIFF_PKG_USED=f
1120 AD_OPTFILE=
1121 TAF=
1122 AD_TAF_FLAGS=
1123 FTL_TAF_FLAGS=
1124 SVD_TAF_FLAGS=
1125 TAF_EXTRA=
1126 TAMC=
1127 AD_TAMC_FLAGS=
1128 FTL_TAF_FLAGS=
1129 SVD_TAMC_FLAGS=
1130 TAMC_EXTRA=
1131
1132
1133 # The following state can be set directly by command-line switches
1134 gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1135 gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI OMP DUMPSTATE STANDARDDIRS"
1136
1137 # The following state is not directly set by command-line switches
1138 gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM FEXTRAFLAGS"
1139 gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1140 gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1141 gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1142 gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1143
1144 # The following are all related to adjoint/tangent-linear stuff
1145 gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
1146 gm_s11="FTL_TAMC_FLAGS FTL_TAF_FLAGS SVD_TAMC_FLAGS SVD_TAF_FLAGS"
1147 gm_s12="TAF_EXTRA TAMC_EXTRA"
1148
1149 gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
1150 gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
1151
1152 cat <<EOF
1153
1154 GENMAKE :
1155
1156 A program for GENerating MAKEfiles for the MITgcm project. For a
1157 quick list of options, use "genmake -h" or for more detail see:
1158
1159 http://mitgcm.org/devel_HOWTO/
1160
1161 EOF
1162
1163 echo "=== Processing options files and arguments ==="
1164 gm_local="genmake_local"
1165 printf " getting local config information: "
1166 if test -f $gm_local ; then
1167 echo "using $gm_local"
1168 . $gm_local
1169 # echo "DISABLE=$DISABLE"
1170 # echo "ENABLE=$ENABLE"
1171 else
1172 echo "none found"
1173 fi
1174
1175 #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1176 #OPTIONS=
1177 #n=0
1178 #for i ; do
1179 # echo "$i $n"
1180 # setvar="OPTIONS[$n]='$i'"
1181 # # echo " $setvar"
1182 # eval "$setvar"
1183 # n=$(( $n + 1 ))
1184 #done
1185 #parse_options
1186 ac_prev=
1187 for ac_option in "$@" ; do
1188
1189 G2ARGS="$G2ARGS \"$ac_option\""
1190
1191 # If the previous option needs an argument, assign it.
1192 if test -n "$ac_prev"; then
1193 eval "$ac_prev=\$ac_option"
1194 ac_prev=
1195 continue
1196 fi
1197
1198 ac_optarg=`expr "x$ac_option" : 'x[^=]*=\(.*\)'`
1199
1200 case $ac_option in
1201
1202 -help | --help | -h | --h)
1203 usage ;;
1204
1205 -nooptfile | --nooptfile)
1206 OPTFILE="NONE" ;;
1207 -optfile | --optfile | -of | --of)
1208 ac_prev=OPTFILE ;;
1209 -optfile=* | --optfile=* | -of=* | --of=*)
1210 OPTFILE=$ac_optarg ;;
1211
1212 -adoptfile | --adoptfile | -adof | --adof)
1213 ac_prev=AD_OPTFILE ;;
1214 -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
1215 AD_OPTFILE=$ac_optarg ;;
1216
1217 -pdepend | --pdepend)
1218 ac_prev=PDEPEND ;;
1219 -pdepend=* | --pdepend=*)
1220 PDEPEND=$ac_optarg ;;
1221
1222 -pdefault | --pdefault)
1223 ac_prev=PDEFAULT ;;
1224 -pdefault=* | --pdefault=*)
1225 PDEFAULT=$ac_optarg ;;
1226
1227 -make | --make | -m | --m)
1228 ac_prev=MAKE ;;
1229 -make=* | --make=* | -m=* | --m=*)
1230 MAKE=$ac_optarg ;;
1231
1232 -bash | --bash)
1233 ac_prev=BASH ;;
1234 -bash=* | --bash=*)
1235 BASH=$ac_optarg ;;
1236
1237 -makedepend | --makedepend | -md | --md)
1238 ac_prev=MAKEDEPEND ;;
1239 -makedepend=* | --makedepend=* | -md=* | --md=*)
1240 MAKEDEPEND=$ac_optarg ;;
1241
1242 -makefile | --makefile | -ma | --ma)
1243 ac_prev=MAKEFILE ;;
1244 -makefile=* | --makefile=* | -ma=* | --ma=*)
1245 MAKEFILE=$ac_optarg ;;
1246
1247 -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
1248 echo "ERROR: The platform option has been removed. Please specify"
1249 echo " the build options using the \"optfile\" mechanism."
1250 echo
1251 usage
1252 ;;
1253
1254 -rootdir | --rootdir | -rd | --rd)
1255 ac_prev=ROOTDIR ;;
1256 -rootdir=* | --rootdir=* | -rd=* | --rd=*)
1257 ROOTDIR=$ac_optarg ;;
1258
1259 -mods | --mods | -mo | --mo)
1260 ac_prev=MODS ;;
1261 -mods=* | --mods=* | -mo=* | --mo=*)
1262 MODS=$ac_optarg ;;
1263
1264 -disable | --disable)
1265 ac_prev=DISABLE ;;
1266 -disable=* | --disable=*)
1267 DISABLE=$ac_optarg ;;
1268
1269 -enable | --enable)
1270 ac_prev=ENABLE ;;
1271 -enable=* | --enable=*)
1272 ENABLE=$ac_optarg ;;
1273
1274 -standarddirs | --standarddirs)
1275 ac_prev=STANDARDDIRS ;;
1276 -standarddirs=* | --standarddirs=*)
1277 STANDARDDIRS=$ac_optarg ;;
1278
1279 # -cpp | --cpp)
1280 # ac_prev=cpp ;;
1281 # -cpp=* | --cpp=*)
1282 # CPP=$ac_optarg ;;
1283
1284 -cc | --cc)
1285 ac_prev=CC ;;
1286 -cc=* | --cc=*)
1287 CC=$ac_optarg ;;
1288
1289 -fortran | --fortran | -fc | --fc)
1290 ac_prev=FC ;;
1291 -fc=* | --fc=*)
1292 FC=$ac_optarg ;;
1293
1294 -fs | --fs)
1295 ac_prev=FS ;;
1296 -fs=* | --fs=*)
1297 FS=$ac_optarg ;;
1298
1299 -fs90 | --fs90)
1300 ac_prev=FS90 ;;
1301 -fs90=* | --fs90=*)
1302 FS90=$ac_optarg ;;
1303
1304 -ieee | --ieee)
1305 IEEE=true ;;
1306 -noieee | --noieee)
1307 IEEE= ;;
1308
1309 -ts | --ts)
1310 TS=true ;;
1311 -papis | --papis)
1312 PAPIS=true ;;
1313 -pcls | --pcls)
1314 PCLS=true ;;
1315 -foolad | --foolad)
1316 FOOLAD=true ;;
1317 -papi | --papi)
1318 PAPI=true ;;
1319 -pcl | --pcl)
1320 PCL=true ;;
1321 -hpmt | --hpmt)
1322 HPMT=true ;;
1323
1324 -gsl | --gsl)
1325 GSL=true ;;
1326
1327 -devel | --devel)
1328 DEVEL=true ;;
1329
1330 -mpi | --mpi)
1331 MPI=true ;;
1332 -mpi=* | --mpi=*)
1333 MPIPATH=$ac_optarg
1334 MPI=true ;;
1335
1336 -omp | --omp)
1337 OMP=true ;;
1338 -omp=* | --omp=*)
1339 OMPFLAG=$ac_optarg
1340 OMP=true ;;
1341
1342 -ds | --ds)
1343 DUMPSTATE=t ;;
1344
1345 -taf_extra | --taf_extra)
1346 ac_prev=TAF_EXTRA ;;
1347 -taf_extra=* | --taf_extra=*)
1348 TAF_EXTRA=$ac_optarg ;;
1349
1350 -tamc_extra | --tamc_extra)
1351 ac_prev=TAMC_EXTRA ;;
1352 -tamc_extra=* | --tamc_extra=*)
1353 TAMC_EXTRA=$ac_optarg ;;
1354
1355 -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1356 IGNORE_TIME="-DIGNORE_TIME" ;;
1357
1358 -es | --es | -embed-source | --embed-source)
1359 EMBED_SRC=t ;;
1360
1361 -*)
1362 echo "Error: unrecognized option: "$ac_option
1363 usage
1364 ;;
1365
1366 *)
1367 echo "Error: unrecognized argument: "$ac_option
1368 usage
1369 ;;
1370
1371 esac
1372
1373 done
1374
1375
1376 if test -f ./.genmakerc ; then
1377 echo
1378 echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1379 echo " file. This file format is no longer supported. For directions on"
1380 echo " how to setup and use the new \"genmake2\" script, please see:"
1381 echo " http://mitgcm.org/devel_HOWTO/"
1382 echo " and send an email to MITgcm-support@mitgcm.org if you need help."
1383 echo "WARNING: ignore \"./.genmakerc\" and continue."
1384 echo
1385 fi
1386
1387 # Find the MITgcm ${ROOTDIR}
1388 if test "x${ROOTDIR}" = x ; then
1389 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1390 if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1391 ROOTDIR=".."
1392 else
1393 for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1394 if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1395 ROOTDIR=$d
1396 printf "Warning: ROOTDIR was not specified but there appears to be"
1397 echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1398 break
1399 fi
1400 done
1401 fi
1402 fi
1403 if test "x${ROOTDIR}" = x ; then
1404 echo "Error: Cannot determine ROOTDIR for MITgcm code."
1405 echo " Please specify a ROOTDIR using either an options "
1406 echo " file or a command-line option."
1407 exit 1
1408 fi
1409 if test ! -d ${ROOTDIR} ; then
1410 echo "Error: the specified ROOTDIR (\"$ROOTDIR\") does not exist!"
1411 exit 1
1412 fi
1413
1414 # Find the MITgcm ${THISVER}
1415 version_file="${ROOTDIR}/doc/tag-index"
1416 if test -f $version_file ; then
1417 THISVER=`grep '^checkpoint' $version_file | head -1`
1418 #- remove ./BUILD_INFO.h file if older than version_file
1419 if test -f ./BUILD_INFO.h -a ./BUILD_INFO.h -ot $version_file ; then
1420 echo " remove ./BUILD_INFO.h (older than ${version_file})"
1421 rm -f ./BUILD_INFO.h
1422 fi
1423 fi
1424
1425 if test "x$MAKEFILE" = x ; then
1426 MAKEFILE="Makefile"
1427 fi
1428
1429 echo " getting OPTFILE information: "
1430 if test "x${OPTFILE}" = x ; then
1431 if test "x$MITGCM_OF" = x ; then
1432 echo "Warning: no OPTFILE specified so we'll look for possible settings"
1433 printf "\n=== Searching for possible settings for OPTFILE ===\n"
1434 find_possible_configs
1435 else
1436 OPTFILE=$MITGCM_OF
1437 fi
1438 fi
1439 if test "x$OPTFILE" != xNONE ; then
1440 if test -f "$OPTFILE" -a -r "$OPTFILE" ; then
1441 echo " using OPTFILE=\"$OPTFILE\""
1442 . "$OPTFILE"
1443 RETVAL=$?
1444 if test "x$RETVAL" != x0 ; then
1445 printf "Error: failed to source OPTFILE \"$OPTFILE\""
1446 echo "--please check that variable syntax is bash-compatible"
1447 exit 1
1448 fi
1449 if test "x$DUMPSTATE" != xf ; then
1450 cp -f $OPTFILE "genmake_optfile"
1451 fi
1452 else
1453 echo "Error: can't read OPTFILE=\"$OPTFILE\""
1454 exit 1
1455 fi
1456 fi
1457
1458 echo " getting AD_OPTFILE information: "
1459 if test "x${AD_OPTFILE}" = x ; then
1460 if test "x$MITGCM_AD_OF" = x ; then
1461 AD_OPTFILE=$ROOTDIR/tools/adjoint_options/adjoint_default
1462 else
1463 AD_OPTFILE=$MITGCM_AD_OF
1464 fi
1465 fi
1466 if test "x${AD_OPTFILE}" != xNONE ; then
1467 if test -f "$AD_OPTFILE" -a -r "$AD_OPTFILE" ; then
1468 echo " using AD_OPTFILE=\"$AD_OPTFILE\""
1469 . "$AD_OPTFILE"
1470 RETVAL=$?
1471 if test "x$RETVAL" != x0 ; then
1472 printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1473 echo "--please check that variable syntax is bash-compatible"
1474 exit 1
1475 fi
1476 if test "x$DUMPSTATE" != xf ; then
1477 cp -f $AD_OPTFILE "genmake_ad_optfile"
1478 fi
1479 else
1480 echo "Error: can't read AD_OPTFILE=\"$AD_OPTFILE\""
1481 exit 1
1482 fi
1483 fi
1484
1485 #====================================================================
1486 # Set default values if not set by the optfile
1487 #
1488 # Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined. If not,
1489 # either set defaults or complain and abort!
1490 if test ! "x$BASH" = x ; then
1491 # add a trailing space so that it works within the Makefile syntax (see below)
1492 BASH="$BASH "
1493 fi
1494 if test "x$FC" = x ; then
1495 cat <<EOF 1>&2
1496
1497 Error: no Fortran compiler: please specify using one of the following:
1498 1) within the options file ("FC=...") as specified by "-of=OPTFILE"
1499 2) the "-fc=XXX" command-line option
1500 3) the "./genmake_local" file
1501 EOF
1502 exit 1
1503 fi
1504 if test "x$CC" = x ; then
1505 CC=cc
1506 # cat <<EOF 1>&2
1507 # Error: no C compiler: please specify using one of the following:
1508 # 1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1509 # 2) the "-cc=XXX" command-line option
1510 # 3) the "./genmake_local" file
1511 # EOF
1512 # exit 1
1513 fi
1514 if test "x$LINK" = x ; then
1515 LINK=$FC
1516 fi
1517 if test "x$MAKE" = x ; then
1518 MAKE="make"
1519 fi
1520 if test "x$CPP" = x ; then
1521 CPP=cpp
1522 fi
1523 #EH3 === UGLY ===
1524 # The following is an ugly little hack to check for $CPP in /lib/ and
1525 # it should eventually be replaced with a more general function that
1526 # searches a combo of the user's path and a list of "usual suspects"
1527 # to find the correct location for binaries such as $CPP.
1528 for i in " " "/lib/" ; do
1529 echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1530 done
1531 #EH3 === UGLY ===
1532 echo "#define A a" | $CPP > test_cpp 2>&1
1533 RETVAL=$?
1534 if test "x$RETVAL" != x0 ; then
1535 cat <<EOF 1>&2
1536
1537 Error: C pre-processor "$CPP" failed the test case: please specify using:
1538
1539 1) within the options file ("CPP=...") as specified by "-of=OPTFILE"
1540 2) the "./genmake_local" file
1541 3) with the CPP environment variable
1542
1543 EOF
1544 exit 1
1545 else
1546 rm -f test_cpp
1547 fi
1548 look_for_makedepend
1549 if test "x$LN" = x ; then
1550 LN="ln -s"
1551 fi
1552 echo "test" > genmake_test_ln
1553 $LN genmake_test_ln genmake_tlink
1554 RETVAL=$?
1555 if test "x$RETVAL" != x0 ; then
1556 cat <<EOF 1>&2
1557
1558 Error: The command "ln -s" failed -- please specify a working soft-link
1559 command in the optfile.
1560
1561 EOF
1562 exit 1
1563 fi
1564 test -L genmake_tlink > /dev/null 2>&1
1565 RETVAL=$?
1566 if test "x$RETVAL" = x0 ; then
1567 HAVE_TEST_L=t
1568 fi
1569 rm -f genmake_test_ln genmake_tlink
1570
1571 # Check for broken *.F/*.f handling and fix if possible
1572 check_for_broken_Ff
1573
1574 if test ! "x$MPI" = x ; then
1575 echo " Turning on MPI cpp macros"
1576 DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1577 fi
1578 if test ! "x$OMP" = x ; then
1579 echo " Add OMPFLAG and turn on OpenMP cpp macros"
1580 FFLAGS="$FFLAGS $OMPFLAG"
1581 F90FLAGS="$F90FLAGS $OMPFLAG"
1582 DEFINES="$DEFINES -DUSE_OMP_THREADING"
1583 fi
1584
1585 if test ! "x$TS" = x ; then
1586 echo " Turning on timing per timestep"
1587 if test ! "x$FOOLAD" = x ; then
1588 DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1589 else
1590 DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1591 fi
1592 PACKAGES="$PACKAGES showflops"
1593 fi
1594 if test ! "x$PAPIS" = x ; then
1595 echo " Turning on PAPI flop summary per timestep"
1596 echo " Please make sure PAPIINC, PAPILIB are defined"
1597 if test ! "x$FOOLAD" = x ; then
1598 DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1599 else
1600 DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1601 fi
1602 INCLUDES="$INCLUDES $PAPIINC"
1603 LIBS="$LIBS $PAPILIB"
1604 PACKAGES="$PACKAGES showflops"
1605 fi
1606 if test ! "x$PCLS" = x ; then
1607 echo " Turning on PCL counter summary per timestep"
1608 echo " Please make sure PCLINC, PCLLIB are defined"
1609 if test ! "x$FOOLAD" = x ; then
1610 DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1611 else
1612 DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1613 fi
1614 INCLUDES="$INCLUDES $PCLINC"
1615 LIBS="$LIBS $PCLLIB"
1616 PACKAGES="$PACKAGES showflops"
1617 fi
1618 if test ! "x$PAPI" = x ; then
1619 if test ! "x$PAPIS" = x ; then
1620 echo " PAPI performance analysis and flop summary per timestep cannot co-exist!"
1621 echo " Sticking with PAPI flop summary per timestep!"
1622 else
1623 echo " Turning on performance analysis with PAPI"
1624 echo " Please make sure PAPIINC, PAPILIB are defined"
1625 DEFINES="$DEFINES -DUSE_PAPI"
1626 INCLUDES="$INCLUDES $PAPIINC"
1627 LIBS="$LIBS $PAPILIB"
1628 fi
1629 fi
1630 if test ! "x$PCL" = x ; then
1631 if test ! "x$PCLS" = x ; then
1632 echo " PCL performance analysis and flop summary per timestep cannot co-exist!"
1633 echo " Sticking with PCL flop summary per timestep!"
1634 else
1635 echo " Turning on performance analysis with PCL"
1636 echo " Please make sure PCLINC, PCLLIB are defined"
1637 DEFINES="$DEFINES -DUSE_PCL"
1638 INCLUDES="$INCLUDES $PCLINC"
1639 LIBS="$LIBS $PCLLIB"
1640 fi
1641 fi
1642 if test ! "x$HPMT" = x ; then
1643 if test ! "x$PAPI" = x ; then
1644 echo " PAPI and the HPM Toolkit cannot co-exist!"
1645 echo " Sticking with PAPI!"
1646 else if test ! "x$PCL" = x ; then
1647 echo " PCL and the HPM Toolkit cannot co-exist!"
1648 echo " Sticking with PCL!"
1649 else
1650 echo " Turning on performance analysis with the HPM Toolkit"
1651 echo " Please make sure HPMTINC, HPMTLIB are defined"
1652 DEFINES="$DEFINES -DUSE_LIBHPM"
1653 INCLUDES="$INCLUDES $HPMTINC"
1654 LIBS="$LIBS $HPMTLIB"
1655 fi
1656 fi
1657 fi
1658 if test ! "x$GSL" = x ; then
1659 echo " Turning on use of GSL to control floating point calculations"
1660 echo " Please make sure GSLINC, GSLLIB are defined"
1661 DEFINES="$DEFINES -DUSE_GSL_IEEE"
1662 INCLUDES="$INCLUDES $GSLINC"
1663 LIBS="$LIBS $GSLLIB"
1664 fi
1665 #- if USE_EXTENDED_SRC is set, add EXTENDED_SRC_FLAG to FFLAGS :
1666 if test ! "x$USE_EXTENDED_SRC" = x ; then
1667 FFLAGS="$FFLAGS $EXTENDED_SRC_FLAG"
1668 F90FIXEDFORMAT="$F90FIXEDFORMAT $EXTENDED_SRC_FLAG"
1669 fi
1670
1671 printf "\n=== Checking system libraries ===\n"
1672 printf " Do we have the system() command using $FC... "
1673 cat > genmake_tcomp.$FS <<EOF
1674 program hello
1675 call system('echo hi')
1676 end
1677 EOF
1678 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1679 RETVAL=$?
1680 if test "x$RETVAL" = x0 ; then
1681 HAVE_SYSTEM=t
1682 DEFINES="$DEFINES -DHAVE_SYSTEM"
1683 echo "yes"
1684 else
1685 HAVE_SYSTEM=
1686 echo "no"
1687 fi
1688 rm -f genmake_tcomp*
1689
1690 printf " Do we have the fdate() command using $FC... "
1691 cat > genmake_tcomp.$FS <<EOF
1692 program hello
1693 CHARACTER*(128) string
1694 string = ' '
1695 call fdate( string )
1696 print *, string
1697 end
1698 EOF
1699 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1700 RETVAL=$?
1701 if test "x$RETVAL" = x0 ; then
1702 HAVE_FDATE=t
1703 DEFINES="$DEFINES -DHAVE_FDATE"
1704 echo "yes"
1705 else
1706 HAVE_FDATE=
1707 echo "no"
1708 fi
1709 rm -f genmake_tcomp*
1710
1711 printf " Do we have the etime() command using $FC... "
1712 cat > genmake_tcomp.$FS <<EOF
1713 program hello
1714 REAL*4 ACTUAL, TARRAY(2)
1715 EXTERNAL ETIME
1716 REAL*4 ETIME
1717 actual = etime( tarray )
1718 print *, tarray
1719 end
1720 EOF
1721 $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1722 RETVAL=$?
1723 if test "x$RETVAL" = x0 ; then
1724 HAVE_ETIME=t
1725 DEFINES="$DEFINES -DHAVE_ETIME"
1726 echo "yes"
1727 else
1728 HAVE_ETIME=
1729 echo "no"
1730 fi
1731 rm -f genmake_tcomp*
1732
1733 printf " Can we call simple C routines (here, \"cloc()\") using $FC... "
1734 check_HAVE_CLOC
1735 if test "x$HAVE_CLOC" != x ; then
1736 echo "yes"
1737 else
1738 echo "no"
1739 if test "x$EMBED_SRC" = xt ; then
1740 echo " WARNING: you requested file embedding but it has"
1741 echo " been disabled since C code cannot be called"
1742 EMBED_SRC=
1743 fi
1744 fi
1745 rm -f genmake_t*
1746
1747 printf " Can we unlimit the stack size using $FC... "
1748 check_HAVE_SETRLSTK
1749 if test "x$HAVE_SETRLSTK" = xt ; then
1750 echo "yes"
1751 else
1752 echo "no"
1753 fi
1754 rm -f genmake_t*
1755
1756 printf " Can we register a signal handler using $FC... "
1757 check_HAVE_SIGREG
1758 if test "x$HAVE_SIGREG" = xt ; then
1759 echo "yes"
1760 else
1761 echo "no"
1762 fi
1763 rm -f genmake_t*
1764
1765 printf " Can we use stat() through C calls... "
1766 check_HAVE_STAT
1767 if test "x$HAVE_STAT" != x ; then
1768 echo "yes"
1769 else
1770 echo "no"
1771 fi
1772 rm -f genmake_t*
1773
1774 printf " Can we create NetCDF-enabled binaries... "
1775 check_netcdf_libs
1776 if test "x$HAVE_NETCDF" != x ; then
1777 echo "yes"
1778 else
1779 echo "no"
1780 fi
1781 DEFINES="$DEFINES $IGNORE_TIME"
1782
1783 if test "x$EMBED_SRC" = xt ; then
1784 build_embed_encode
1785 fi
1786 if test "x$EMBED_SRC" = xt ; then
1787 ENABLE="$ENABLE embed_files"
1788 fi
1789
1790
1791 printf "\n=== Setting defaults ===\n"
1792 printf " Adding MODS directories: "
1793 for d in $MODS ; do
1794 if test ! -d $d ; then
1795 echo
1796 echo "Error: MODS directory \"$d\" not found!"
1797 exit 1
1798 else
1799 printf "$d "
1800 SOURCEDIRS="$SOURCEDIRS $d"
1801 INCLUDEDIRS="$INCLUDEDIRS $d"
1802 fi
1803 done
1804 echo
1805
1806 if test "x${PLATFORM}" = x ; then
1807 PLATFORM=$p_PLATFORM
1808 fi
1809
1810 if test "x${EXEDIR}" = x ; then
1811 tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1812 if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1813 EXEDIR=../exe
1814 else
1815 EXEDIR=.
1816 fi
1817 fi
1818 if test ! -d ${EXEDIR} ; then
1819 echo "Error: the specified EXEDIR (\"$EXEDIR\") does not exist!"
1820 exit 1
1821 fi
1822
1823 if test "x${TOOLSDIR}" = x ; then
1824 TOOLSDIR="$ROOTDIR/tools"
1825 fi
1826 if test ! -d ${TOOLSDIR} ; then
1827 echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1828 exit 1
1829 fi
1830 if test "x$S64" = x ; then
1831 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1832 RETVAL=$?
1833 if test "x${RETVAL}" = x0 ; then
1834 S64='$(TOOLSDIR)/set64bitConst.sh'
1835 else
1836 echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1837 RETVAL=$?
1838 if test "x${RETVAL}" = x0 ; then
1839 S64='$(TOOLSDIR)/set64bitConst.csh'
1840 else
1841 cat <<EOF
1842
1843 ERROR: neither of the two default scripts:
1844
1845 ${TOOLSDIR}/set64bitConst.sh
1846 ${TOOLSDIR}/set64bitConst.csh
1847
1848 are working so please check paths or specify (with \$S64) a
1849 working version of this script.
1850
1851 EOF
1852 exit 1
1853 fi
1854 fi
1855 fi
1856 THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1857
1858 EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1859
1860 # We have a special set of source files in eesupp/src which are
1861 # generated from some template source files. We'll make them first so
1862 # they appear as regular source code
1863 if test -r $ROOTDIR"/eesupp/src/Makefile" ; then
1864 echo " Making source files in eesupp from templates"
1865 ( cd $ROOTDIR"/eesupp/src/" && $MAKE ) > make_eesupp.errors 2>&1
1866 RETVAL=$?
1867 if test "x${RETVAL}" = x0 ; then
1868 rm -f make_eesupp.errors
1869 else
1870 echo "Error: problem encountered while building source files in eesupp:"
1871 cat make_eesupp.errors 1>&2
1872 exit 1
1873 fi
1874 fi
1875
1876 #same for pkg/exch2 and pkg/regrid
1877 for pdir in exch2 regrid ; do
1878 if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1879 echo " Making source files in pkg/${pdir} from templates"
1880 ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1881 RETVAL=$?
1882 if test "x${RETVAL}" = x0 ; then
1883 rm -f make_${pdir}.errors
1884 else
1885 echo "Error: problem encountered while building source files in pkg/${pdir}:"
1886 cat make_${pdir}.errors 1>&2
1887 exit 1
1888 fi
1889 fi
1890 done
1891
1892 printf "\n=== Determining package settings ===\n"
1893 if test "x${PDEPEND}" = x ; then
1894 tmp=$ROOTDIR"/pkg/pkg_depend"
1895 if test -r $tmp ; then
1896 PDEPEND=$tmp
1897 else
1898 echo "Warning: No package dependency information was specified."
1899 echo " Please check that ROOTDIR/pkg/pkg_depend exists."
1900 fi
1901 else
1902 if test ! -r ${PDEPEND} ; then
1903 echo "Error: can't read package dependency info from PDEPEND=\"$PDEPEND\""
1904 exit 1
1905 fi
1906 fi
1907 echo " getting package dependency info from $PDEPEND"
1908 # Strip the comments and then convert the dependency file into
1909 # two arrays: PNAME, DNAME
1910 cat $PDEPEND | sed -e 's/#.*$//g' \
1911 | $AWK 'BEGIN{nn=-1;} (NF>0){ for(i=2;i<=NF;i++){nn++; print "PNAME_"nn"="$1"\nDNAME_"nn"="$i}} END{print "nname="nn}' \
1912 > ./.pd_tmp
1913 RETVAL=$?
1914 if test ! "x${RETVAL}" = x0 ; then
1915 echo "Error: unable to parse package dependencies -- please check PDEPEND=\"$PDEPEND\""
1916 exit 1
1917 fi
1918 . ./.pd_tmp
1919 rm -f ./.pd_tmp
1920
1921 # Search for default packages. Note that a "$ROOTDIR/pkg/pkg_groups"
1922 # file should eventually be added so that, for convenience, one can
1923 # specify groups of packages using names like "ocean" and "atmosphere".
1924 echo " checking default package list: "
1925 if test "x${PDEFAULT}" = x ; then
1926 for i in "." $MODS ; do
1927 if test -r $i"/packages.conf" ; then
1928 PDEFAULT=$i"/packages.conf"
1929 break
1930 fi
1931 done
1932 fi
1933 if test "x${PDEFAULT}" = x ; then
1934 PDEFAULT="$ROOTDIR/pkg/pkg_default"
1935 fi
1936 if test "x${PDEFAULT}" = xNONE ; then
1937 echo " default packages file disabled"
1938 else
1939 if test ! -r $PDEFAULT ; then
1940 echo "Warning: can't read default packages from PDEFAULT=\"$PDEFAULT\""
1941 else
1942 echo " using PDEFAULT=\"$PDEFAULT\""
1943 # Strip the comments and add all the names
1944 def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1945 RETVAL=$?
1946 if test "x${RETVAL}" != x0 ; then
1947 printf "Error: can't parse default package list "
1948 echo "-- please check PDEFAULT=\"$PDEFAULT\""
1949 exit 1
1950 fi
1951 for i in $def ; do
1952 PACKAGES="$PACKAGES $i"
1953 done
1954 echo " before group expansion packages are: $PACKAGES"
1955 RET=1
1956 while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1957 echo " after group expansion packages are: $PACKAGES"
1958 fi
1959 fi
1960
1961 echo " applying DISABLE settings"
1962 for i in $PACKAGES ; do
1963 echo $i >> ./.tmp_pack
1964 done
1965 for i in `grep "-" ./.tmp_pack` ; do
1966 j=`echo $i | sed 's/[-]//'`
1967 DISABLE="$DISABLE $j"
1968 done
1969 pack=
1970 for p in $PACKAGES ; do
1971 addit="t"
1972 for d in $DISABLE ; do
1973 if test "x$p" = "x$d" ; then
1974 addit="f"
1975 fi
1976 done
1977 if test "x$addit" = xt ; then
1978 pack="$pack $p"
1979 fi
1980 done
1981 PACKAGES="$pack"
1982 echo " applying ENABLE settings"
1983 echo "" > ./.tmp_pack
1984 PACKAGES="$PACKAGES $ENABLE"
1985 # Test if each explicitly referenced package exists
1986 for i in $PACKAGES ; do
1987 j=`echo $i | sed 's/[-+]//'`
1988 if test ! -d "$ROOTDIR/pkg/$j" ; then
1989 echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1990 exit 1
1991 fi
1992 echo $i >> ./.tmp_pack
1993 done
1994 PACKAGES=
1995 for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1996 PACKAGES="$PACKAGES $i"
1997 done
1998 rm -f ./.tmp_pack
1999 echo " packages are: $PACKAGES"
2000
2001 # Check for package MNC: if NetCDF is available, then build the MNC
2002 # template files ; otherwise, delete mnc from the list of packages.
2003 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
2004 RETVAL=$?
2005 if test "x$RETVAL" = x0 ; then
2006 if test "x$HAVE_NETCDF" != xt ; then
2007 cat <<EOF
2008
2009 *********************************************************************
2010 WARNING: the "mnc" package was enabled but tests failed to compile
2011 NetCDF applications. Please check that:
2012
2013 1) NetCDF is correctly installed for this compiler and
2014 2) the LIBS variable (within the "optfile") specifies the correct
2015 NetCDF library to link against.
2016
2017 Due to this failure, the "mnc" package is now DISABLED.
2018 *********************************************************************
2019
2020 EOF
2021 PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
2022 DISABLE="$DISABLE mnc"
2023 else
2024 ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
2025 RETVAL=$?
2026 if test "x${RETVAL}" = x0 ; then
2027 rm -f make_mnc.errors
2028 else
2029 echo "Error: problem encountered while building source files in pkg/mnc:"
2030 cat make_mnc.errors 1>&2
2031 exit 1
2032 fi
2033 fi
2034 fi
2035
2036 # Check for package PROFILES: if NetCDF is not available,
2037 # then delete profiles from the list of available packages.
2038 echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2039 RETVAL=$?
2040 if test "x$RETVAL" = x0 ; then
2041 if test "x$HAVE_NETCDF" != xt ; then
2042 cat <<EOF
2043
2044 *********************************************************************
2045 WARNING: the "profiles" package was enabled but tests failed to
2046 compile NetCDF applications. Please check that:
2047
2048 1) NetCDF is correctly installed for this compiler and
2049 2) the LIBS variable (within the "optfile") specifies the correct
2050 NetCDF library to link against.
2051
2052 Due to this failure, the "profiles" package is now DISABLED.
2053 *********************************************************************
2054
2055 EOF
2056 PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2057 DISABLE="$DISABLE profiles"
2058 fi
2059 fi
2060
2061 echo " applying package dependency rules"
2062 ck=
2063 while test "x$ck" != xtt ; do
2064 i=0
2065 # rtot=${#PNAME[@]}
2066 rtot=$nname
2067 while test $i -le $rtot ; do
2068
2069 # Is $pname in the current $PACKAGES list?
2070 # pname=${PNAME[$i]}
2071 tmp="pname=\"\$PNAME_$i\""
2072 eval $tmp
2073 pin="f"
2074 for p in $PACKAGES ; do
2075 if test "x$p" = "x$pname" ; then
2076 pin="t"
2077 fi
2078 done
2079
2080 # Is the DNAME entry a (+) or (-) rule ?
2081 tmp="dname=\"\$DNAME_$i\""
2082 eval $tmp
2083 plus="-"
2084 echo $dname | grep '^+' > /dev/null 2>&1
2085 RETVAL=$?
2086 if test "x$RETVAL" = x0 ; then
2087 plus="+"
2088 fi
2089
2090 # Is $dname in the current $PACKAGES list?
2091 dname=`echo $dname | sed -e 's/^[+-]//'`
2092 din="f"
2093 for p in $PACKAGES ; do
2094 if test "x$p" = "x$dname" ; then
2095 din="t"
2096 fi
2097 done
2098
2099 # Do we need to add $dname according to the dependency rules?
2100 if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2101 #echo " " $pname ": need to add :" $dname
2102 in_dis="f"
2103 for dis in $DISABLE ; do
2104 if test "x$dis" = "x$dname" ; then
2105 in_dis="t"
2106 fi
2107 done
2108 if test "x$in_dis" = xt ; then
2109 echo "Error: can't satisfy package dependencies:"
2110 echo " \"$dname\" is required by the dependency rules"
2111 echo " but is disallowed by the DISABLE settings"
2112 exit 1
2113 else
2114 PACKAGES="$PACKAGES $dname"
2115 ck=
2116 fi
2117 fi
2118
2119 # Do we need to get rid of $dname according to the dependency rules?
2120 if test "x$pin" = xt -a "x$plus" = "x-" -a "x$din" = xt; then
2121 echo "Error: can't satisfy package dependencies:"
2122 echo " \"$pname\" was requested but is disallowed by"
2123 echo " the dependency rules for \"$dname\""
2124 exit 1
2125 fi
2126 i=`echo "$i + 1" | bc -l`
2127 #i=$(( $i + 1 ))
2128 done
2129 ck=$ck"t"
2130 done
2131 echo " packages are: $PACKAGES"
2132 for i in $PACKAGES ; do
2133 adr="$ROOTDIR/pkg/$i"
2134 if test -d $adr ; then
2135 SOURCEDIRS="$SOURCEDIRS $adr"
2136 INCLUDEDIRS="$INCLUDEDIRS $adr"
2137 if test "x$i" = xautodiff ; then
2138 AUTODIFF_PKG_USED=t
2139 fi
2140 else
2141 echo "Error: the directory \"$adr\" for package $i doesn't exist"
2142 exit 1
2143 fi
2144 done
2145
2146 # Create a list of #define and #undef to enable/disable packages
2147 PACKAGES_DOT_H=PACKAGES_CONFIG.h
2148 # The following UGLY HACK sets multiple "#undef"s and it needs to go
2149 # away. On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
2150 # file would eventually be split up so that all package-related #define
2151 # statements could be separated and handled only by genmake.
2152 names=`ls -1 "$ROOTDIR/pkg"`
2153 all_pack=
2154 DISABLED_PACKAGES=
2155 for n in $names ; do
2156 if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
2157 has_pack="f"
2158 for pack in $PACKAGES ; do
2159 if test "x$pack" = "x$n" ; then
2160 has_pack="t"
2161 break
2162 fi
2163 done
2164 if test "x$has_pack" = xf ; then
2165 undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2166 DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2167 fi
2168 fi
2169 done
2170 ENABLED_PACKAGES=
2171 for i in $PACKAGES ; do
2172 def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2173 ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2174 #eh3 DEFINES="$DEFINES -D$def"
2175
2176 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2177 case $i in
2178 aim_v23)
2179 ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
2180 echo "Warning: ALLOW_AIM is set to enable aim_v23."
2181 ;;
2182 esac
2183 #EH3 WARNING : This is an UGLY HACK that needs to be removed!!!
2184
2185 done
2186
2187 echo " Adding STANDARDDIRS"
2188 BUILDDIR=${BUILDDIR:-.}
2189 if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
2190 STANDARDDIRS="eesupp model"
2191 fi
2192 if test "x$STANDARDDIRS" != x ; then
2193 for d in $STANDARDDIRS ; do
2194 adr="$ROOTDIR/$d/src"
2195 if test ! -d $adr ; then
2196 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2197 echo " is correct and that you correctly specified the STANDARDDIRS option"
2198 exit 1
2199 else
2200 SOURCEDIRS="$SOURCEDIRS $adr"
2201 fi
2202 adr="$ROOTDIR/$d/inc"
2203 if test ! -d $adr ; then
2204 echo "Error: directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
2205 echo " is correct and that you correctly specified the STANDARDDIRS option"
2206 exit 1
2207 else
2208 INCLUDEDIRS="$INCLUDEDIRS $adr"
2209 fi
2210 done
2211 fi
2212
2213 echo " Searching for *OPTIONS.h files in order to warn about the presence"
2214 echo " of \"#define \"-type statements that are no longer allowed:"
2215 CPP_OPTIONS=
2216 CPP_EEOPTIONS=
2217 spaths=". $INCLUDEDIRS"
2218 names=`ls -1 "$ROOTDIR/pkg"`
2219 for i in $spaths ; do
2220 try="$i/CPP_OPTIONS.h"
2221 if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
2222 echo " found CPP_OPTIONS=\"$try\""
2223 CPP_OPTIONS="$try"
2224 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
2225 for n in $names ; do
2226 test_for_package_in_cpp_options $CPP_OPTIONS $n
2227 done
2228 fi
2229 try="$i/CPP_EEOPTIONS.h"
2230 if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
2231 echo " found CPP_EEOPTIONS=\"$try\""
2232 # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
2233 #**** not yet enabled ****
2234 # test_for_mpi_in_cpp_eeoptions $try
2235 #**** not yet enabled ****
2236 CPP_EEOPTIONS="$try"
2237 fi
2238 done
2239 if test "x$CPP_OPTIONS" = x ; then
2240 echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
2241 exit 1
2242 fi
2243
2244 # Here, we build the list of files to be "run through" the adjoint
2245 # compiler.
2246 if test -f ./adSrcFiles.tmp ; then
2247 rm -f ./adSrcFiles.tmp
2248 fi
2249 echo " Creating the list of files for the adjoint compiler."
2250 for i in $SOURCEDIRS ; do
2251 list_files=`( cd $i && ls -1 *.list 2>/dev/null )`
2252 for j in $list_files ; do
2253 cat $i/$j >> adSrcFiles.tmp
2254 done
2255 done
2256 if test ! "x"$FS = "x.f" ; then
2257 cat adSrcFiles.tmp | sed -e "s/\.f/.$FS/g" > adSrcFiles.tmp_f
2258 mv -f adSrcFiles.tmp_f adSrcFiles.tmp
2259 fi
2260
2261 echo
2262 echo "=== Creating the Makefile ==="
2263 echo " setting INCLUDES"
2264 for i in $INCLUDEDIRS ; do
2265 if test ! -d $i ; then
2266 echo "Warning: can't find INCLUDEDIRS=\"$i\""
2267 fi
2268 done
2269
2270 if test ! "x$DIVA" = x ; then
2271 echo " Creating the pseudo-MPI include directory"
2272 INCLUDES="-I./mpi_headers $INCLUDES"
2273 rm -rf ./mpi_headers
2274 mkdir -p ./mpi_headers
2275
2276 if test "x$MPIINCLUDEDIR" = x ; then
2277 if test "x$MPIHOME" = x ; then
2278 MPIHOME='/usr'
2279 fi
2280 MPIINCLUDEDIR='$MPIHOME/include'
2281 fi
2282
2283 if test -r $MPIINCLUDEDIR/mpif.h ; then
2284 for i in $MPI_HEADER_FILES; do
2285 cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2286 done
2287
2288 perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2289 else
2290 echo " We cannot create a copy of mpif.h!"
2291 # exit -1
2292 fi
2293 fi
2294
2295 echo " Determining the list of source and include files"
2296 rm -rf .links.tmp
2297 mkdir .links.tmp
2298 touch .links.tmp/foo
2299 if test ! -r ".links.tmp/foo" ; then
2300 echo
2301 echo "ERROR : something is wrong with your directory permissions or"
2302 echo " your user file-creation mask (\"umask\") since creating a"
2303 echo " sub-dir, touch-ing a file within it, and then reading it is"
2304 echo " not working. Please try setting your umask to something"
2305 echo " sane such as:"
2306 echo
2307 echo " umask 0002"
2308 echo
2309 echo " and please verify that you have the proper permissions for"
2310 echo " creating sub-directories and then reading files created"
2311 echo " within them."
2312 echo
2313 exit 1
2314 fi
2315 rm -f .links.tmp/foo
2316
2317 if test "x$OPENAD" != x ; then
2318 OAD_DONT_COMPILE="/dev/null"
2319 OAD_DONT_TRANSFORM="/dev/null"
2320 OAD_KEEP_ORIGINAL="/dev/null"
2321 OAD_CB2M_FILES="/dev/null"
2322 echo " looking for dontCompile file: "
2323 for i in "." $MODS ; do
2324 if test -r $i"/dontCompile" ; then
2325 OAD_DONT_COMPILE=$i"/dontCompile"
2326 echo " found $OAD_DONT_COMPILE"
2327 break
2328 fi
2329 done
2330 echo " looking for dontTransform file: "
2331 for i in "." $MODS ; do
2332 if test -r $i"/dontTransform" ; then
2333 OAD_DONT_TRANSFORM=$i"/dontTransform"
2334 echo " found $OAD_DONT_TRANSFORM"
2335 break
2336 fi
2337 done
2338 echo " looking for keepOriginal file: "
2339 for i in "." $MODS ; do
2340 if test -r $i"/keepOriginal" ; then
2341 OAD_KEEP_ORIGINAL=$i"/keepOriginal"
2342 echo " found $OAD_KEEP_ORIGINAL"
2343 break
2344 fi
2345 done
2346 echo " looking for cb2mFiles: "
2347 for i in "." $MODS ; do
2348 if test -r $i"/cb2mFiles" ; then
2349 OAD_CB2M_FILES=$i"/cb2mFiles"
2350 echo " found $OAD_CB2M_FILES"
2351 break
2352 fi
2353 done
2354 echo " OpenAD exceptions: "
2355 fi
2356
2357 echo "# This section creates symbolic links" > srclinks.tmp
2358 echo "" >> srclinks.tmp
2359 printf 'F77_SRC_FILES = ' > F77srclist.tmp
2360 printf 'NON_AD_F77_SRC_FILES = ' > nonADF77srclist.tmp
2361 printf 'C_SRC_FILES = ' > csrclist.tmp
2362 printf 'F90_SRC_FILES = ' > F90srclist.tmp
2363 printf 'H_SRC_FILES = ' > hsrclist.tmp
2364 printf 'AD_FLOW_FILES = ' > ad_flow_files.tmp
2365 alldirs="$SOURCEDIRS $INCLUDEDIRS ."
2366 for d in $alldirs ; do
2367 deplist=
2368 sfiles=`( cd $d; echo *.[h,c,F] *.flow )`
2369 sfiles=`( echo $sfiles; cd $d; echo *.F90 )`
2370 if test "x$OPENAD" != x ; then
2371 sfiles=`( echo $sfiles | grep -v _cb2m\. )`
2372 fi
2373 for sf in $sfiles ; do
2374 if test ! -r ".links.tmp/$sf" ; then
2375 if test -f "$d/$sf" ; then
2376 ignore_f=f
2377 case $d/$sf in
2378 ./$PACKAGES_DOT_H)
2379 ignore_f=t
2380 ;;
2381 ./AD_CONFIG.h)
2382 ignore_f=t
2383 ;;
2384 ./FC_NAMEMANGLE.h)
2385 ignore_f=t
2386 ;;
2387 ./BUILD_INFO.h)
2388 ignore_f=t
2389 ;;
2390 ./EMBEDDED_FILES.h)
2391 ignore_f=t
2392 ;;
2393 *)
2394 # For the local directory *ONLY*,
2395 # ignore all soft-links
2396 if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2397 ignore_f=t
2398 else
2399 touch .links.tmp/$sf
2400 deplist="$deplist $sf"
2401 fi
2402 ;;
2403 esac
2404 if test "x$ignore_f" = xf ; then
2405 extn=`echo $sf | $AWK -F. '{print $NF}'`
2406 case $extn in
2407 F)
2408 echo " \\" >> F77srclist.tmp
2409 printf " $sf" >> F77srclist.tmp
2410 if test "x$OPENAD" != x ; then
2411 basename=${sf%%.F}
2412 isAD=`egrep ^$basename.f'[ ]*' adSrcFiles.tmp`
2413 if test -z "$isAD" ; then
2414 toBeIgnored=`egrep ^$basename'[ ]*' ${OAD_DONT_COMPILE}`
2415 if test -z "$toBeIgnored" ; then
2416 echo " \\" >> nonADF77srclist.tmp
2417 printf " $sf" >> nonADF77srclist.tmp
2418 else
2419 echo " not to be compiled : $sf"
2420 fi
2421 else # file is initially listed as an AD file we want to exclude it
2422 # or we want to retain the untransformed version
2423 notToBeTransformed=`egrep ^$basename'[ ]*' ${OAD_DONT_TRANSFORM}`
2424 untransformedVersionToBeKept=`egrep ^$basename'[ ]*' ${OAD_KEEP_ORIGINAL}`
2425 if test -n "$notToBeTransformed"; then
2426 echo " not to be transformed: $sf"
2427 fi
2428 if test -n "$untransformedVersionToBeKept" ; then
2429 echo " original to be kept : $sf"
2430 fi
2431 if test -n "$notToBeTransformed" -o -n "$untransformedVersionToBeKept" ; then
2432 echo " \\" >> nonADF77srclist.tmp
2433 printf " $sf" >> nonADF77srclist.tmp
2434 fi
2435 fi
2436 fi
2437 ;;
2438 F90)
2439 echo " \\" >> F90srclist.tmp
2440 printf " $sf" >> F90srclist.tmp
2441 ;;
2442 c)
2443 echo " \\" >> csrclist.tmp
2444 printf " $sf" >> csrclist.tmp
2445 ;;
2446 h)
2447 echo " \\" >> hsrclist.tmp
2448 printf " $sf" >> hsrclist.tmp
2449 ;;
2450 flow)
2451 echo " \\" >> ad_flow_files.tmp
2452 printf " $sf" >> ad_flow_files.tmp
2453 ;;
2454 esac
2455 fi
2456 fi
2457 fi
2458 done
2459 if test "x$deplist" != x ; then
2460 if test "$d" != "." ; then
2461 echo "" >> srclinks.tmp
2462 echo "# These files are linked from $d" >> srclinks.tmp
2463 echo "$deplist :" >> srclinks.tmp
2464 # We need to make sure that the link isn't already there.
2465 # This may happen when make thinks that a header file has to be "remade"
2466 # because a module it depends on has changed. In this case we do nothing.
2467 printf "\tif [ ! -L \$@ ]; then \$(LN) %s/\$@ \$@; fi\n" $d >> srclinks.tmp
2468 fi
2469 fi
2470 done
2471 rm -rf .links.tmp
2472 echo "" >> F77srclist.tmp
2473 echo "" >> nonADF77srclist.tmp
2474 echo "" >> csrclist.tmp
2475 echo "" >> F90srclist.tmp
2476 echo "" >> hsrclist.tmp
2477 echo "" >> ad_flow_files.tmp
2478
2479 if test -f $MAKEFILE ; then
2480 mv -f $MAKEFILE "$MAKEFILE.bak"
2481 fi
2482 echo " Writing makefile: $MAKEFILE"
2483 echo "# Multithreaded + multi-processing makefile for:" > $MAKEFILE
2484 echo "# $MACHINE" >> $MAKEFILE
2485 echo "# This makefile was generated automatically on" >> $MAKEFILE
2486 echo "# $THISDATE" >> $MAKEFILE
2487 echo "# by the command:" >> $MAKEFILE
2488 echo "# $0 $G2ARGS" >> $MAKEFILE
2489 echo "# executed by:" >> $MAKEFILE
2490 echo "# ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2491
2492 EXE_AD=$EXECUTABLE"_ad"
2493 EXE_FTL=$EXECUTABLE"_ftl"
2494 EXE_SVD=$EXECUTABLE"_svd"
2495
2496 cat >>$MAKEFILE <<EOF
2497 #
2498 # OPTFILE="$OPTFILE"
2499 #
2500 # BUILDDIR : Directory where object files are written
2501 # SOURCEDIRS : Directories containing the source (.F) files
2502 # INCLUDEDIRS : Directories containing the header-source (.h) files
2503 # EXEDIR : Directory where executable that is generated is written
2504 # EXECUTABLE : Full path of executable binary
2505 #
2506 # CPP : C-preprocessor command
2507 # INCLUDES : Directories searched for header files
2508 # DEFINES : Macro definitions for CPP
2509 # MAKEDEPEND : Dependency generator
2510 # KPP : Special preprocessor command (specific to platform)
2511 # KFLAGS : Flags for KPP
2512 # FC : Fortran compiler command
2513 # FFLAGS : Configuration/debugging options for FC
2514 # FOPTIM : Optimization options for FC
2515 # LINK : Command for link editor program
2516 # LIBS : Library flags /or/ additional optimization/debugging flags
2517
2518 ROOTDIR = ${ROOTDIR}
2519 BUILDDIR = ${BUILDDIR}
2520 SOURCEDIRS = ${SOURCEDIRS}
2521 INCLUDEDIRS = ${INCLUDEDIRS}
2522 EXEDIR = ${EXEDIR}
2523 EXECUTABLE = \$(EXEDIR)/${EXECUTABLE}
2524 TOOLSDIR = ${TOOLSDIR}
2525
2526 #eh3 new defines for the adjoint work
2527 AUTODIFF = ${ROOTDIR}/pkg/autodiff
2528 EXE_AD = ${EXE_AD}
2529 EXE_FTL = ${EXE_FTL}
2530 EXE_SVD = ${EXE_SVD}
2531
2532 ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2533 DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2534
2535 # These files are created by Makefile
2536 SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
2537 EOF
2538
2539 if test "x$EMBED_SRC" = xt ; then
2540 echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2541 else
2542 echo "EMBEDDED_FILES = " >>$MAKEFILE
2543 fi
2544
2545 cat >>$MAKEFILE <<EOF
2546 # Unix ln (link)
2547 LN = ${LN}
2548 # C preprocessor
2549 CPP = cat \$< | ${S64} | ${CPP}
2550 # Dependency generator
2551 MAKEDEPEND = ${MAKEDEPEND}
2552 # Special preprocessor (KAP on DECs, FPP on Crays)
2553 KPP = ${KPP}
2554 # Fortran compiler
2555 FC = ${FC}
2556 # Fortran compiler
2557 F90C = ${F90C}
2558 # C compiler
2559 CC = ${CC}
2560 # Link editor
2561 LINK = ${LINK} ${LDADD}
2562
2563 # Defines for CPP
2564 DEFINES = ${DEFINES}
2565 # Includes for CPP
2566 INCLUDES = ${INCLUDES}
2567 # Flags for KPP
2568 KFLAGS1 = ${KFLAGS1}
2569 KFLAGS2 = ${KFLAGS2}
2570 # Optim./debug for FC
2571 FFLAGS = ${FFLAGS} ${FEXTRAFLAGS}
2572 FOPTIM = ${FOPTIM}
2573 # Optim./debug for FC
2574 F90FLAGS = ${F90FLAGS}
2575 F90OPTIM = ${F90OPTIM}
2576 F90FIXEDFORMAT = ${F90FIXEDFORMAT}
2577 # Flags for CC
2578 CFLAGS = ${CFLAGS}
2579 # Files that should not be optimized
2580 NOOPTFILES = ${NOOPTFILES}
2581 NOOPTFLAGS = ${NOOPTFLAGS}
2582 # Flags and libraries needed for linking
2583 LIBS = ${LIBS}
2584 # Name of the Mekfile
2585 MAKEFILE=${MAKEFILE}
2586
2587 EOF
2588
2589 cat F77srclist.tmp >> $MAKEFILE
2590 cat nonADF77srclist.tmp >> $MAKEFILE
2591 cat csrclist.tmp >> $MAKEFILE
2592 cat F90srclist.tmp >> $MAKEFILE
2593 cat hsrclist.tmp >> $MAKEFILE
2594 cat ad_flow_files.tmp >> $MAKEFILE
2595
2596 rm -f F77srclist.tmp nonADF77srclist.tmp csrclist.tmp F90srclist.tmp hsrclist.tmp ad_flow_files.tmp
2597
2598 echo >> $MAKEFILE
2599
2600 # add definitions for preprocessed sources
2601 # and note that not all systems allow case sensitive extensions
2602 # hence the $FS and $FS90 here.
2603 # for fixed format f90 files we use ff90 or FF90 resp
2604 # but these are not expected to be the original source files
2605
2606 echo 'F77_PP_SRC_FILES = $(F77_SRC_FILES:.F=.'$FS')' >> $MAKEFILE
2607 echo 'F90_PP_SRC_FILES = $(F90_SRC_FILES:.F90=.'$FS90')' >> $MAKEFILE
2608 echo 'OBJFILES= $(F77_SRC_FILES:.F=.o) $(C_SRC_FILES:.c=.o) $(F90_SRC_FILES:.F90=.o)' >> $MAKEFILE
2609 echo 'FLOFILES = $(AD_FLOW_FILES:.flow=.flowdir)' >> $MAKEFILE
2610 echo >> $MAKEFILE
2611 echo '.SUFFIXES:' >> $MAKEFILE
2612 echo '.SUFFIXES: .o .'$FS' .p .F .c .f'$FS90' .'$FS90' .FF90 .F90 .flowdir .flow' >> $MAKEFILE
2613
2614 cat >>$MAKEFILE <<EOF
2615
2616 all: \$(EXECUTABLE)
2617 \$(EXECUTABLE): \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2618 @echo Creating \$@ ...
2619 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2620 depend:
2621 @make links
2622 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2623 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2624 -rm -f makedepend.out
2625
2626 lib: libmitgcmuv.a
2627
2628 libmitgcmuv.a: \$(OBJFILES)
2629 ar rcv libmitgcmuv.a \$(OBJFILES)
2630 ar d libmitgcmuv.a main.o
2631
2632 links: \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(SPECIAL_FILES)
2633
2634 small_f: \$(F77_PP_SRC_FILES) \$(F90_PP_SRC_FILES)
2635
2636 output.txt: \$(EXECUTABLE)
2637 @printf 'running ... '
2638 @\$(EXECUTABLE) > \$@
2639
2640 clean:
2641 -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2642 -rm -rf *.o
2643 -rm -rf *.$FS *.flowdir
2644 -rm -rf *.f$FS90 *_mod.h *_mod.F90 *.FF90 *.mod-whirl ad_input*
2645 -rm -rf temp.sed
2646 Clean:
2647 @make clean
2648 @make cleanlinks
2649 -rm -f \$(SPECIAL_FILES)
2650 -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log f90mkdepend.log *.bak
2651 -rm -f taf_command taf_output taf_ad.log taf_ad_flow.log
2652 CLEAN:
2653 @make Clean
2654 -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2655 -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2656 -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2657 -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2658 -rm -f *_MIT_CE_000.opt0000 costfunction*0000
2659 -rm -rf mnc_test_*
2660
2661 #eh3 Makefile: makefile
2662 makefile:
2663 $THIS_SCRIPT $G2ARGS
2664 cleanlinks:
2665 -find . -type l -exec rm {} \;
2666
2667 # Special targets (SPECIAL_FILES) which are created by make
2668 ${PACKAGES_DOT_H}:
2669 @echo Creating \$@ ...
2670 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
2671 AD_CONFIG.h:
2672 @echo Creating \$@ ...
2673 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
2674 FC_NAMEMANGLE.h:
2675 @echo Creating \$@ ...
2676 echo "$FC_NAMEMANGLE" > \$@
2677
2678 BUILD_INFO.h:
2679 @echo Creating \$@ ...
2680 EOF
2681
2682 test ! "x$THISVER" = x && echo " -echo \"#define THISVER '$THISVER'\" > \$@" >> $MAKEFILE
2683 test ! "x$THISUSER" = x && echo " -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2684 test ! "x$THISDATE" = x && echo " -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2685 test ! "x$THISHOST" = x && echo " -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2686
2687 if test "x$EMBED_SRC" = xt ; then
2688 cat >>$MAKEFILE <<EOF
2689
2690 decode_files.o : EMBEDDED_FILES.h
2691
2692 ## \$(F77_PP_SRC_FILES)
2693 all_fF.tar.gz : \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2694 @echo Creating \$@ ...
2695 -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(F77_SRC_FILES) \$(C_SRC_FILES) \$(H_SRC_FILES) \$(F90_SRC_FILES) \$(F77_PP_SRC_FILES) Makefile
2696 -rm -f all_fF.tar.gz
2697 -gzip all_fF.tar
2698
2699 EMBEDDED_FILES.h : all_fF.tar.gz
2700 @echo Creating \$@ ...
2701 -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2702
2703 EOF
2704 fi
2705
2706 cat >>$MAKEFILE <<EOF
2707
2708 # The normal chain of rules is ( .F - .$FS - .o )
2709
2710 ## This nullifies any default implicit rules concerning these two file types:
2711 ## %.o : %.F
2712
2713 .F.$FS:
2714 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2715 .$FS.o:
2716 \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2717 .F90.$FS90:
2718 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2719 .FF90.f$FS90:
2720 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2721 .$FS90.o:
2722 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2723 .f$FS90.o:
2724 cp \$< \$(basename \$<).f90
2725 \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$(F90FIXEDFORMAT) \$(basename \$<).f90
2726 .c.o:
2727 \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2728 .flow.flowdir:
2729 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2730
2731 # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2732 .F.p:
2733 \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2734 .p.$FS:
2735 \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
2736
2737 EOF
2738
2739 #=========================================
2740 #=== Automatic Differentiation Rules ===
2741 #=== for TAMC/TAF ======================
2742
2743 if test "x$OPENAD" = x ; then
2744
2745 cat >>$MAKEFILE <<EOF
2746
2747 TAMC = ${TAMC}
2748 TAF = ${TAF}
2749
2750 TAF_EXTRA = ${TAF_EXTRA}
2751 TAMC_EXTRA = ${TAMC_EXTRA}
2752
2753 EOF
2754
2755 ad_vars="AD_TAMC_FLAGS AD_TAF_FLAGS"
2756 ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF_FLAGS"
2757 ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2758 for i in $ad_vars ; do
2759 name=$i
2760 t1="t2=\$"`echo "$i"`
2761 eval $t1
2762 printf "%-20s = " $name >> $MAKEFILE
2763 echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2764 done
2765
2766 echo " Add the source list for AD code generation"
2767 echo >> $MAKEFILE
2768 printf "AD_FILES = " >> $MAKEFILE
2769 AD_FILES=`cat adSrcFiles.tmp`
2770 for i in $AD_FILES ; do
2771 echo " \\" >> $MAKEFILE
2772 printf " $i" >> $MAKEFILE
2773 done
2774 echo >> $MAKEFILE
2775 rm -f adSrcFiles.tmp
2776
2777 cat >>$MAKEFILE <<EOF
2778
2779 # ... AD ...
2780 adall: \$(EXE_AD)
2781 adtaf: ad_taf_output.$FS
2782 adtamc: ad_tamc_output.$FS
2783
2784 ad_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES) \$(AD_FLOW_FILES)
2785 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2786 cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2787 -rm -f ad_config.template
2788 @make \$(F77_PP_SRC_FILES)
2789 @make \$(FLOFILES)
2790 cat \$(FLOFILES) \$(AD_FILES) > ad_input_code.$FS
2791
2792 ad_taf_output.$FS: ad_input_code.$FS
2793 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2794 ls -l ad_input_code_ad.$FS
2795 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2796
2797 adtafonly:
2798 \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2799 ls -l ad_input_code_ad.$FS
2800 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2801
2802 \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2803 \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2804
2805 ad_tamc_output.$FS: ad_input_code.$FS
2806 \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2807 cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2808
2809 ad_tamc: ad_tamc_output.o \$(OBJFILES)
2810 \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2811
2812 adonlyfwd:
2813 patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2814
2815 adtrick:
2816 patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2817
2818 # ... FTL ...
2819 ftlall: ftl_taf
2820 ftltaf: ftl_taf_output.$FS
2821 ftltamc: ftl_tamc_output.$FS
2822
2823 ftl_input_code.$FS: \$(AD_FILES) \$(H_SRC_FILES)
2824 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2825 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2826 -rm -f ftl_config.template
2827 @make \$(F77_PP_SRC_FILES)
2828 @make \$(AD_FLOW_FILES)
2829 cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2830
2831 ftl_taf_output.$FS: ftl_input_code.$FS
2832 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2833 ls -l ftl_input_code_ftl.$FS
2834 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2835
2836 ftltafonly:
2837 \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2838 ls -l ftl_input_code_ftl.$FS
2839 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2840
2841 ftl_taf: ftl_taf_output.o \$(OBJFILES)
2842 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2843
2844 ftl_tamc_output.$FS: ftl_input_code.$FS
2845 \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2846 cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2847
2848 ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2849 \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2850
2851
2852 # ... SVD ...
2853 svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2854 @echo "--->>> Only ran TAF to generate SVD code! <<<---"
2855 @echo "--->>> Do make svdall afterwards to compile. <<<---"
2856 svdall: svd_touch svd_taf
2857
2858 svd_taf: \$(OBJFILES)
2859 \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2860
2861 @echo "--->>> Only COMPILE svd code! <<<---"
2862 @echo "--->>> Assumes you previously <<<---"
2863 @echo "--->>> did make svdtaf <<<---"
2864
2865 svd_touch:
2866 @echo "--->>> Only COMPILE svd code! <<<---"
2867 @echo "--->>> Assumes you previously <<<---"
2868 @echo "--->>> did make svdtaf <<<---"
2869 touch ad_taf_output.$FS ftl_taf_output.$FS
2870 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2871 \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2872 @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2873 cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2874 -rm -f ftl_config.template
2875
2876 EOF
2877
2878 fi
2879
2880 #=== for OpenAD ========================
2881
2882 if test "x$OPENAD" != x ; then
2883
2884 # ============ begin OpenAD specific section ==============
2885
2886 cat >>$MAKEFILE <<EOF
2887
2888 # all the source files linked from the various locations:
2889 ALL_LINKED_FILES= \
2890 \$(F77_SRC_FILES) \
2891 \$(C_SRC_FILES) \
2892 \$(H_SRC_FILES) \
2893 \$(F90_SRC_FILES) \
2894 \$(SPECIAL_FILES)
2895
2896 ifndef OPENADROOT
2897 \$(error "Error: environment variable OPENADROOT not defined!")
2898 endif
2899
2900 ifndef XAIFSCHEMAROOT
2901 \$(error "Error: environment variable XAIFSCHEMAROOT not defined!")
2902 endif
2903
2904 ifndef XAIFBOOSTERROOT
2905 \$(error "Error: environment variable XAIFBOOSTERROOT not defined!")
2906 endif
2907
2908 EOF
2909
2910 echo " Add the source list for common block to module conversion "
2911 echo >> $MAKEFILE
2912 printf "CB2M_F90_SRC_NAMES = " >> $MAKEFILE
2913 for i in `cat ${OAD_CB2M_FILES}` ; do
2914 echo " \\" >> $MAKEFILE
2915 printf " $i" >> $MAKEFILE
2916 done
2917 echo >> $MAKEFILE
2918
2919 echo " Add the source list for AD code generation"
2920 echo >> $MAKEFILE
2921 printf "AD_FILES = " >> $MAKEFILE
2922 for i in `cat ${OAD_CB2M_FILES}` ; do
2923 echo " \\" >> $MAKEFILE
2924 printf " ${i}_mod.f$FS90" >> $MAKEFILE
2925 done
2926 AD_FILES=`cat adSrcFiles.tmp`
2927 for i in $AD_FILES ; do
2928 basename=${i%%.f}
2929 toBeIgnored=`egrep ^$basename'[ ]*' ${OAD_DONT_COMPILE} ${OAD_DONT_TRANSFORM}`
2930 if test -z "$toBeIgnored" ; then
2931 echo " \\" >> $MAKEFILE
2932 printf " $i" >> $MAKEFILE
2933 fi
2934 done
2935 echo >> $MAKEFILE
2936 rm -f adSrcFiles.tmp
2937
2938 cat >>$MAKEFILE <<EOF
2939
2940 adAll: \$(EXE_AD)
2941 .PHONY: adAll
2942
2943 CB2M_F90_PP_SRC_FILES=\$(addsuffix _mod.f$FS90, \$(CB2M_F90_SRC_NAMES))
2944
2945 .PRECIOUS: \$(CB2M_F90_PP_SRC_FILES) \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90)
2946
2947 .PHONY: adDepend
2948 adDepend: \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(addsuffix _mod.FF90, \$(CB2M_F90_SRC_NAMES)) \$(F77_SRC_FILES:.F=_cb2m.FF90)
2949 \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(F77_SRC_FILES)
2950 \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2951 -rm -f makedepend.out
2952
2953 OPENAD_SUPPORT_F90_SRC_FILES = \
2954 w2f__types.F90 \
2955 OAD_active.F90 \
2956 OAD_cp.F90 \
2957 OAD_rev.F90 \
2958 OAD_tape.F90
2959
2960 OPENAD_SUPPORT_C_SRC_FILES = \
2961 iaddr.c \
2962 timeRatio.c
2963
2964 f95_test_mods.f90: \$(OPENAD_SUPPORT_F90_SRC_FILES:F90=$FS90)
2965 cat \$^ > \$@
2966
2967 f95_test.f90: all_mods.xb.x2w.w2f.pp.f$FS90 \$(NON_AD_F77_SRC_FILES:.F=_cb2m.f$FS90) ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2968 cat \$^ > \$@
2969
2970 f95_test.out: f95_test_mods.f90 f95_test.f90
2971 f95 -fixed -w=unused -maxcontin=132 -c f95_test_mods.f90 > \$@ 2>&1
2972 f95 -fixed -w=unused -maxcontin=132 -c -fixed f95_test.f90 >> \$@ 2>&1
2973
2974 AD_OBJ_FILES=\$(OPENAD_SUPPORT_F90_SRC_FILES:.F90=.o) \$(OPENAD_SUPPORT_C_SRC_FILES:.c=.o) all_mods.xb.x2w.w2f.pp.o ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.o \$(NON_AD_F77_SRC_FILES:.F=_cb2m.o) \$(C_SRC_FILES:.c=.o) \$(F90_SRC_FILES:.F90=.o)
2975
2976 \$(EXE_AD): \$(ALL_LINKED_FILES) \$(addsuffix _mod.h, \$(CB2M_F90_SRC_NAMES)) \$(AD_OBJ_FILES)
2977 @echo Creating \$@ ...
2978 \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(AD_OBJ_FILES) \$(LIBS)
2979
2980 # makefile debug rule
2981 openad: ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
2982 .PHONY: openad
2983
2984 # create the module files
2985 %_mod.FF90 : %.h ../OAD_support/cb2mGetModules.csh ../OAD_support/cb2mGetModules.awk
2986 ../OAD_support/cb2mGetModules.csh $< ../OAD_support/cb2mGetModules.awk
2987
2988 # create the header files
2989 %_mod.h : %.h ../OAD_support/cb2mGetHeaders.csh ../OAD_support/cb2mGetHeaders.awk
2990 ../OAD_support/cb2mGetHeaders.csh $< ../OAD_support/cb2mGetHeaders.awk \$(CB2M_F90_SRC_NAMES)
2991
2992 # change everybody else to use the new module files:
2993 %_cb2m.FF90 : %.F ../OAD_support/cb2mUseModules.bash
2994 ../OAD_support/cb2mUseModules.bash $< ${MPI}
2995
2996 # makefile debug rule
2997 small_f: \$(CB2M_F90_PP_SRC_FILES)
2998 .PHONY: small_f
2999
3000 ad_output.txt: \$(EXE_AD)
3001 @printf 'linking data files ... '
3002 \$(LN) -f ../input_ad/data* ../input_ad/eedata .
3003 \$(LN) -f ../../global_ocean.90x40x15/input/*.bin .
3004 @printf 'running ... '
3005 @./\$(EXE_AD) > \$@
3006
3007 CB2M_AD_FILES=\$(AD_FILES:.f=_cb2m.f$FS90)
3008 ad_input_code.f$FS90: ../OAD_support/maxMinDefs.f \$(CB2M_AD_FILES)
3009 cat \$^ > \$@
3010
3011 # strip all comments and blanks to reduce
3012 # the file size in order to reduce perl's memory requirements
3013 ad_input_code_sf.f$FS90 : ad_input_code.f$FS90
3014 cat \$^ | sed -f ../OAD_support/strip.sed | sed -f ../OAD_support/stop2print.sed > \$@
3015
3016 # mfef90 preprocessing
3017 # expand statement functions
3018 # expose mfef90 specific substring handling
3019 # add the w2f__types module
3020 ad_input_code_sf.w2f.f$FS90: ad_input_code_sf.f$FS90 mfef90 whirl2f whirl2f_be w2f__types.f90
3021 ./mfef90 -r8 -z -F -N132 \$<
3022 mv \$<.B \$(basename \$<).B
3023 ./whirl2f -openad \$(basename \$<).B
3024 cat w2f__types.f90 \$(basename \$<).w2f.f > \$@
3025
3026 # canonicalizer
3027 ad_input_code_sf.w2f.pre.f$FS90: ad_input_code_sf.w2f.f$FS90 preProcess.py
3028 ./preProcess.py -H -S \$< -o \$@
3029
3030 # F -> WHIRL
3031 # note that the canonicalized version cuts off at col 72
3032 # doing this also for string constants which is ok as long
3033 # as we are in fixed mode and cut of exactly there.
3034 # Otherwise mfef90 patches in spaces to fill up to 72 (or 132)
3035 # characters respectively.
3036 ad_input_code_sf.w2f.pre.B: ad_input_code_sf.w2f.pre.f$FS90 mfef90
3037 ./mfef90 -r8 -z -F \$<
3038 mv \$<.B \$@
3039
3040 # WHIRL -> XAIF
3041 ad_input_code_sf.w2f.pre.xaif : ad_input_code_sf.w2f.pre.B whirl2xaif
3042 ./whirl2xaif -s -n --debug 1 -o \$@ \$<
3043
3044 # XAIF -> XAIF'
3045 ad_input_code_sf.w2f.pre.xb.xaif : ad_input_code_sf.w2f.pre.xaif xaif.xsd xaif_base.xsd xaif_inlinable_intrinsics.xsd xaif_derivative_propagator.xsd xaif_output.xsd oadDriver
3046 ./oadDriver -f -t forward_step -i \$< -c \${XAIFSCHEMAROOT}/schema/examples/inlinable_intrinsics.xaif -o \$@ -I -r
3047
3048 # XAIF' -> WHIRL'
3049 ad_input_code_sf.w2f.pre.xb.x2w.B : ad_input_code_sf.w2f.pre.xb.xaif xaif2whirl
3050 ./xaif2whirl --debug 1 --structured ad_input_code_sf.w2f.pre.B \$<
3051
3052 # WHIRL' -> F'
3053 ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.B whirl2f whirl2f_be
3054 ./whirl2f -FLIST:ftn_file=\$@ -openad \$<
3055
3056 # insert template directives
3057 ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.f$FS90 ../OAD_support/insertTemplateDir.bash
3058 ../OAD_support/insertTemplateDir.bash \$< \$@
3059
3060 PPEXTRAS=\$(wildcard ../OAD_support/ad_template.*.F) ../OAD_support/ad_inline.F
3061 # postprocess F'
3062 ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.f$FS90 postProcess.py \$(PPEXTRAS:.F=.f)
3063 ./postProcess.py -m r -i ../OAD_support/ad_inline.f -o \$@ \$<
3064
3065 # extract all transformed modules
3066 all_mods.xb.x2w.w2f.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3067 cat \$< | sed -n '/MODULE /,/END MODULE/p' > \$@
3068
3069 # remove the transformed globals module from the
3070 # transformed ad_input_code file
3071 # and remove for now the duplicate variables
3072 # and fix 2 data statements
3073 ad_input_code.w2f.pre.xb.x2w.w2f.td.pp.f$FS90: ad_input_code_sf.w2f.pre.xb.x2w.w2f.td.pp.f$FS90
3074 cat \$< | sed '/MODULE /,/END MODULE/d' | sed '/^ INTEGER(w2f__i4) DOLOOP_UB/d' > \$@
3075
3076 # setup some links
3077 %.xsd:
3078 \$(LN) \${XAIFSCHEMAROOT}/schema/\$@ .
3079
3080 mfef90:
3081 \$(LN) \${OPEN64ROOT}/crayf90/sgi/mfef90 .
3082
3083 # link the support files:
3084 \$(OPENAD_SUPPORT_F90_SRC_FILES) \$(OPENAD_SUPPORT_C_SRC_FILES):
3085 \$(LN) ../OAD_support/\$@ .
3086
3087 whirl2xaif xaif2whirl:
3088 \$(LN) \${OPENADFORTTK}/bin/\$@ .
3089
3090 preProcess.py postProcess.py:
3091 \$(LN) \${OPENADFORTTK_BASE}/tools/SourceProcessing/\$@ .
3092
3093 whirl2f whirl2f_be:
3094 \$(LN) \${OPEN64ROOT}/whirl2f/\$@ .
3095
3096 oadDriver:
3097 \$(LN) \${XAIFBOOSTERROOT}/xaifBooster/algorithms/BasicBlockPreaccumulationReverse/driver/oadDriver \$@
3098
3099 # ============ end OpenAD specific section ==============
3100
3101 EOF
3102
3103 fi
3104
3105 #=========================================
3106
3107 if test "x$EXEHOOK" != x ; then
3108 printf "\nexehook:\n\t%s\n" $EXEHOOK >> $MAKEFILE
3109 fi
3110
3111 echo " Making list of \"exceptions\" that need \".p\" files"
3112 for i in $KPPFILES ; do
3113 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
3114 RETVAL=$?
3115 if test "x$RETVAL" != x0 ; then
3116 echo "Error: unable to add file \"$i\" to the exceptions list"
3117 fi
3118 echo "$base.$FS: $base.p" >> $MAKEFILE
3119 done
3120
3121 echo " Making list of NOOPTFILES"
3122 for i in $NOOPTFILES ; do
3123 base=`echo $i | sed -e 's/\/.*\///g' | sed -e 's/\..*$//g'`
3124 RETVAL=$?
3125 if test "x$RETVAL" != x0 ; then
3126 echo "Error: unable to add file \"$i\" to the exceptions list"
3127 fi
3128 echo "$base.o: $base.$FS" >> $MAKEFILE
3129 printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
3130 done
3131
3132 echo " Add rules for links"
3133 cat srclinks.tmp >> $MAKEFILE
3134 rm -f srclinks.tmp
3135
3136 echo " Adding makedepend marker"
3137 printf "\n\n# DO NOT DELETE\n" >> $MAKEFILE
3138
3139 printf "\n=== Done ===\n"
3140
3141 # Create special header files
3142 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
3143 if test ! -f $PACKAGES_DOT_H ; then
3144 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
3145 else
3146 cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
3147 RETVAL=$?
3148 if test "x$RETVAL" = x0 ; then
3149 rm -f $PACKAGES_DOT_H".tmp"
3150 else
3151 mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
3152 mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
3153 fi
3154 fi
3155 if test ! -f AD_CONFIG.h ; then
3156 $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
3157 fi
3158
3159
3160 # Write the "state" for future records
3161 if test "x$DUMPSTATE" != xf ; then
3162 printf "" > genmake_state
3163 for i in $gm_state ; do
3164 t1="t2=\$$i"
3165 eval $t1
3166 echo "$i='$t2'" >> genmake_state
3167 done
3168 fi

  ViewVC Help
Powered by ViewVC 1.1.22